
/* **********************************
 File:Block.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 29.01.1999 11:17:44
 Comments: Part of the vIDE Projectbloc begin..end instantiat
***********************************/

package engine;

public class Block extends Instruction{
  
  public void execute()throws InterpretTimeException, SimulationStoppedException{
    xConsole.trace(this + " begin->" + (delayBefore > 0 ? "#" + delayBefore : ""));
    long t0 = Time.oClock();
    if (delayBefore > 0){
      while(Time.oClock() < t0)
        ControlThread.goSleepy();
    }
    if(first != null)first.execute();
    xConsole.trace(this + " <-end");
    if(next != null) next.execute();
  }
  
  Instruction first = null;
  
  public Block(NameSpace ns, int delayBefore, InstructionDescription desc,
               Instruction first, Instruction next){
    super(ns, delayBefore, desc);
    this.next = next;
    this.first = first;
  }
  
  public String toString(){
    //because desc is also a NameSpaceDescription, it must propagate the lineNo, and thus the calling form 
    //is a little bit tricky
    return ((BlockDescription)desc).toString(desc.line);
  }
}


