
/* **********************************
 File:CaseInstruction.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 24.03.1999 14:04:46
 Comments: Part of the vIDE Project
***********************************/

package engine;

import java.util.*;

class CaseInstruction extends Instruction{
  Expression sw;
  Vector choices;
  int type;

 // v = { expresie, instructiune, expresie, instructiune, ... }  
 // pt. default, expresie = null.
 // ceva de genul 
 //    case (x)
 //       v1:
 //       v2: instructiune;
 //    endcase
 // se scrie { v1, null, v2, instructiune }
  CaseInstruction(NameSpace ns, int db, InstructionDescription desc,
                  int type, Expression e, Vector v, Instruction next){
    super(ns, db, desc);
    sw = e;  choices = v;  this.type = type;
    add(next);
  }

  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    BinaryExpression be;
    Instruction ii, id = null;
    Expression ex;
    xConsole.trace(toString());
    for (Enumeration e = choices.elements(); e.hasMoreElements(); ) {
      ex = (Expression)(e.nextElement());
      ii = (Instruction)(e.nextElement());
      if (ex == null) { id = ii;  continue; }
      try {
        be = new BinaryExpression(ns, sw, "==", ex);
      } catch (ParseException exc){
        throw new InterpretTimeException(desc + ": error:" + exc);
      }
      boolean tmp = false;
      try{
        tmp = be.evaluate().isTrue();
      }catch(InterpretTimeException exc){
        xConsole.dumpStack(exc);
        throw new InterpretTimeException(desc + ": error:" + exc);
      }
      if (tmp) {
        xConsole.trace("case: matched to " + ex);
        while (ii == null && e.hasMoreElements()) {
          ex = (Expression)(e.nextElement());
          ii = (Instruction)(e.nextElement());
        }
        if (ii != null) ii.execute();
        if (next != null) next.execute();
        return;
      }
    }
    if (id != null) {
      xConsole.trace("case: no match: doing default");
      id.execute();
    } else xConsole.trace("case: no match: doing nothing");
    if (next != null) next.execute();
  }
}





