/* **********************************
 File:IfInstructionDescription.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 24.03.1999 13:09:00
 Comments: Part of the vIDE Project
***********************************/

package engine;

import java.util.*;

class CaseInstructionDescription extends InstructionDescription{
  ExpressionDescription ed;
  Vector choices;
  int type;
  
  CaseInstructionDescription(int db, int line, NameSpaceDescription nsd,
                             int type, ExpressionDescription ed, Vector v){
    super(db, line, nsd);
    this.ed = ed;  this.type = type;  choices = v;
  }
  
  Instruction instantiate(NameSpace ns)throws ParseException{
  
    Vector v = new Vector();
    InstructionDescription id;
    ExpressionDescription edt;
    Expression edInstance;
    for (Enumeration e = choices.elements(); e.hasMoreElements(); ) {
      try{
        edt = (ExpressionDescription)(e.nextElement());
        v.addElement(edt == null ? null : edt.instantiate(ns)); 
      }catch(ParseException ex){
        xConsole.dumpStack(ex);
        throw new ParseException(super.toString() + " error:" + ex);
      }
      id = (InstructionDescription)(e.nextElement());
      v.addElement(id == null ? null : id.instantiate(ns));
    }

    try{
      edInstance = ed.instantiate(ns);
    }catch(ParseException ex){
      xConsole.dumpStack(ex);
      throw new ParseException(super.toString() + " error:" + ex);
    }

    return new CaseInstruction(ns, delayBefore, this, type, edInstance, v,
                                 next == null ? null : next.instantiate(ns));
  }

  public String toString(){
    return super.toString() + "case (" + ed + "):";
  }
}












