
/* **********************************
 File:Constant.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 03.02.1999 21:22:24
 Comments: Part of the vIDE Project
***********************************/

package engine;

/**
 * A constant seen as expression. Also implements some useful constant expressions as 0.
 */
class Constant extends Expression{

  /**
   * a binary pure zero
   */
  public static Constant zero;
  static{
    try{
      zero = (Constant) ConstantDescription.zeroDescription.instantiate(null);
    }catch(ParseException ex){}
  }
  
  Result data;
  ConstantDescription desc; 


  public Constant(NameSpace ns, Result data, ConstantDescription desc)
  {
    super(ns);
    //    xConsole.debug("new Constant: "+data);
    this.desc = desc;
    this.data = data;
  }
  
  public Result evaluate(){
    return data.duplicate();
  }
  
  public String toString(){
    return desc.toString();
  }
  
  void addMonitor(Monitor m){} 

  public boolean isLeftValue(){
    return false;
  }
  
}



