
/* **********************************
 File:ContAssignMonitorDescription.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 03.02.1999 20:28:40
 Comments: Part of the vIDE Project
***********************************/

package engine;

class ContAssignMonitorDescription extends MonitorDescription{
  SelectionExpressionDescription lValue;
  int lineNo;
  Delay3Description delays;
  
  ContAssignMonitorDescription(NameSpaceDescription nsd, int lineNo, SelectionExpressionDescription lValue, 
    ExpressionDescription target, Delay3Description delays){
    super(nsd, target);
    this.lValue = lValue;
    this.lineNo = lineNo;
    this.delays = delays;
  }
  
  Monitor instantiate(NameSpace ns)throws ParseException{
    try{
      return new ContAssignMonitor(ns, (SelectionExpression)lValue.instantiate(ns), 
                                   target.instantiate(ns), delays.instantiate(ns));
    }catch(ParseException ex){
      xConsole.dumpStack(ex);
      throw new ParseException (ns.desc.toString(lineNo) +  ": error:" +  ex);
    }catch(InterpretTimeException ex){
      xConsole.dumpStack(ex);
      throw new ParseException (ns.desc.toString(lineNo) + ": error:" + ex); 
    }
  }
  
}



