
/* **********************************
 File:CoutTask.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 12.02.1999 02:41:30
 Comments: Part of the vIDE Project
***********************************/

package engine;

class CoutTask extends Instruction{
  Expression target;
  
  CoutTask(NameSpace ns, int delayBefore, InstructionDescription desc,
              Expression target, Instruction next){
    super(ns, delayBefore, desc);
    this.target = target;
    add(next);
  }
  
  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    try{
      xConsole.trace(">>>" + target +" = " + target.evaluate());
    }catch(InterpretTimeException ex){
      xConsole.dumpStack(ex);
      throw new InterpretTimeException(desc + ": error:" + ex);
    }
    xConsole.consumeStep();    
    if(next != null)next.execute();
  }
  
}

