
/* **********************************
 File:CoutTaskDescription.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 12.02.1999 02:41:34
 Comments: Part of the vIDE Project
***********************************/

package engine;

class CoutTaskDescription extends InstructionDescription{
  int id;
  ExpressionDescription ex;
  
  CoutTaskDescription(int delayBefore, int line,
                         NameSpaceDescription nsd, ExpressionDescription ex){
    super(delayBefore, line, nsd);
    this.ex = ex;
  }
  
  Instruction instantiate(NameSpace ns)throws ParseException{

    Expression exInstance;
    try{
      exInstance = ex.instantiate(ns);
    }catch(ParseException ex){
      xConsole.dumpStack(ex);
      throw new ParseException(super.toString() + " error:" + ex);
    }

    return new CoutTask(ns, delayBefore, this, exInstance,
                        next == null ? null : next.instantiate(ns));
  }
  
}

