
/* **********************************
 File:EmptyInstruction.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 12.02.1999 02:41:36
 Comments: Part of the vIDE Project
***********************************/

package engine;

class EmptyInstruction extends Instruction{
  
  public EmptyInstruction(EmptyInstruction original){
    super(original.ns, original.delayBefore, original.desc);
  }
  
  public EmptyInstruction(NameSpace ns, int delaybefore, InstructionDescription desc,
                          Instruction next){
    super(ns, delaybefore, desc);
    add(next);
  }
  
  public void execute()throws InterpretTimeException, SimulationStoppedException{
    
    long t0 = Time.oClock();
    
    if(delayBefore != 0){
      t0 += delayBefore;
      xConsole.trace("#" + delayBefore);
      while(Time.oClock() < t0)
        ControlThread.goSleepy();
    }
    
    if(next != null) next.execute();
    
  }
  public Object clone()
  {
    return new EmptyInstruction(this);
  }
}

