
/* **********************************
 File:Executable.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 06.05.1999 10:01
 Comments: Part of the vIDE Project
***********************************/

package engine;

/**
 * An instruction or othe thing that can be "executed".
 */

interface Executable{

  void execute ()throws InterpretTimeException, SimulationStoppedException;
  
  /**
   * Links the given Executable with this one, so executing the
   * current one will also cause the linked one to be executed.
   * @return the old link
   */
  Executable add(Executable next);

}
