
/* **********************************
 File:ForInstruction.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 16:14:46
 Comments: Part of the vIDE Project
***********************************/

package engine;

class ForInstruction extends Instruction{
  Expression cond;
  Instruction i, initial, step;
  
  ForInstruction(NameSpace ns, int db, InstructionDescription desc, Instruction ia,
                 Expression ee, Instruction si, Instruction i, Instruction next){
    super(ns, db, desc);
    cond = ee;  this.i = i;  initial = ia;  step = si;
    add(next);
  }

  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    xConsole.trace(toString());
    if (initial != null) {
      xConsole.trace("for->");
      initial.execute();
    }
    int k = 0;
    while (true) {
      try{
        if(cond != null)
          if(!cond.evaluate().isTrue())break;
      }catch(InterpretTimeException ex){
        xConsole.dumpStack(ex);
        throw new InterpretTimeException(desc + ": error:" + ex);
      }
      if (i != null) i.execute();
      if (step != null) step.execute();
      k++;
    }
    xConsole.trace("<-for : " + k + " cycles performed");
    if (next != null) next.execute();
  }

}
