
/* **********************************
 File:Fork.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 17.04.1999 06:54:44
 Comments: Part of the vIDE Project
***********************************/

package engine;

/**
 * a fork..join block instance
 */

public class Fork extends Instruction{  
  Instruction first = null;
  volatile boolean anyThreadStarted;
  ControlThread ctrlTh;
  int count;
  
  public Fork(NameSpace ns, int delayBefore, InstructionDescription desc,
               Instruction first, Instruction next){
    super(ns, delayBefore, desc);
    this.next = next;
    this.first = first;
  }
  
  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    count = 0;
    int k = 0;
    ctrlTh = (ControlThread)Thread.currentThread();
    xConsole.trace(toString() + "->");
    for (Instruction i = first; i != null; i = (Instruction)i.next, k++){
      ControlThread rk = new ForkThread(this, i);
      Time.controlThreads.addElement(rk);
      rk.start();
      xConsole.debug("started: " + i);
    }
    xConsole.debug("fork: " + k + " threads start()-ed");
    while (!anyThreadStarted);
    while (count > 0) ctrlTh.goSleepy();
    xConsole.trace("<-"+this);
    if (next != null) next.execute();
  }

  void wakeUp(){
    ctrlTh.wakeUp();
  }
}
