/* **********************************
 File:ForkThread.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 17.04.1999 07:02:44
 Comments: Part of the vIDE Project
***********************************/

package engine;
import java.util.*;

/**
 * A newly fork'ed thread
 */

class ForkThread extends ControlThread{
  Fork launcher;

  ForkThread(Fork launcher, Executable rocket) {
    super(rocket);
    this.launcher = launcher;
  }

  public void run() {
    try{
      launcher.anyThreadStarted = true;
      launcher.count++;
      try{
        ins.execute();
      }catch(InterpretTimeException ex){
        xConsole.dumpStack(ex);
        xConsole.cout(ex.toString());
        Time.stopSimulation();
      }
      Time.removeThread(this);
      launcher.count--;
      launcher.wakeUp();
    }catch(SimulationStoppedException ex){
      xConsole.debug(ex + " " + this);
    }
  }
}
