
/* **********************************
 File:FunctionCallExpression.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on Sun May  2 15:57:32 EDT 1999
 Comments: Part of the vIDE Project
***********************************/

package engine;

import java.util.*;

class FunctionCallExpression extends Expression{
  
  /**
   * The expressions of the actual parameters
   */
  Vector paramExps;
  Vector paramInstances;
  Instruction theFunction;
  FunctionDescription  funcDescription;
  ExpressionDescription desc;

  FunctionCallExpression(NameSpace  ns, ExpressionDescription desc, FunctionDescription funcDescription, 
                  Vector paramExps, Vector paramInstances,  Instruction theFunction){
    super(ns);
    this.desc = desc;
    this.funcDescription = funcDescription;
    this.paramExps = paramExps;
    this.paramInstances = paramInstances;
    this.theFunction = theFunction;
  }

  /**
   * Adds a monitor on the result's placeholder.
   */
  void addMonitor(Monitor m){
    ((DataHolder)paramInstances.elementAt(0)).addMonitor(m);
  }

  boolean isLeftValue(){
    return false;
  }

  public Result evaluate() throws InterpretTimeException{
    xConsole.debug(this + " |->");
    funcDescription.storeParamValues(paramExps, paramInstances);
    try{
      if(theFunction != null)theFunction.execute();
    }catch(SimulationStoppedException ex){
      Time.stopSimulation();
    }
    xConsole.debug(this + " <-|");
    Object o = paramInstances.elementAt(0);
    try{
      if(o instanceof Register)return ((Register)o).getData(0).duplicate();
    }catch(ParseException ex){xConsole.dumpStack(ex);}
    return ((Result)o).duplicate();
  }

  public String toString(){
    return desc.toString();
  }
}



