
/* **********************************
 File:IfInstruction.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 16:06:46
 Comments: Part of the vIDE Project
***********************************/

package engine;

class IfInstruction extends Instruction{
  Expression cond;
  Instruction iTrue, iFalse;
  
  IfInstruction(NameSpace ns, int db, InstructionDescription desc,
                Expression e, Instruction iT, Instruction iF, Instruction next){
    super(ns, db, desc);
    cond = e;  iTrue = iT;  iFalse = iF;
    add(next);
  }

  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    boolean tmp;
    try{
      tmp = cond.evaluate().isTrue();
    }catch(InterpretTimeException ex){
      xConsole.dumpStack(ex);
      throw new InterpretTimeException(desc + ": error:" + ex);
    }
    xConsole.debug(toString() + (tmp ? "" : "skipping"));
    if (tmp) iTrue.execute();
    else if (iFalse != null) iFalse.execute();
    if (next != null) next.execute();
  }

}
