/* **********************************
 File:IfInstructionDescription.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 16:05:00
 Comments: Part of the vIDE Project
***********************************/

package engine;

class IfInstructionDescription extends InstructionDescription{
  ExpressionDescription ed;
  InstructionDescription idTrue, idFalse;
  
  IfInstructionDescription(int db, int line, NameSpaceDescription nsd, ExpressionDescription ed,
                           InstructionDescription idTrue, InstructionDescription idFalse){
    super(db, line, nsd);
    this.ed = ed;  this.idTrue = idTrue;  this.idFalse = idFalse;
  }
  
  Instruction instantiate(NameSpace ns)throws ParseException{

    Expression edInstance;
    try{
      edInstance = ed.instantiate(ns);
    }catch(ParseException ex){
      xConsole.dumpStack(ex);
      throw new ParseException(super.toString() + " error:" + ex);
    }

    return new IfInstruction(ns, delayBefore, this, edInstance, idTrue.instantiate(ns),
      idFalse == null ? null : idFalse.instantiate(ns), next == null ? null : next.instantiate(ns));
  }

  public String toString(){
    return super.toString() + "if( " + ed + ")";
  }
}










