
/* **********************************
 File:Instruction.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 12.02.1999 02:42:26
 Comments: Part of the vIDE Project
***********************************/

package engine;

public abstract class Instruction implements Executable{


  /**
   * the NameSpace instance wich contains this instruction
   */
  NameSpace ns;

  /**
   * the next instruction into this block
   */
  Executable next;

  /**
   * what d'u think it is ??
   */
  int  delayBefore;

  /**
   * this instruction's description
   */

  InstructionDescription desc;

  Instruction(NameSpace ns, int delayBefore, InstructionDescription desc){
    this.ns = ns;
    this.delayBefore = delayBefore;
    this.desc = desc;
  }

  public Executable add(Executable next){
    Executable old = this.next;
    this.next = next;
    return old;
  }
  
  long waitToRun()throws SimulationStoppedException {
    if(!xConsole.enableExecution()){
      xConsole.debug("exit received");
      Time.stopSimulation();
      throw new SimulationStoppedException();
    }
    long t0 = Time.oClock();
    if(delayBefore != 0){
      t0 += delayBefore;
      xConsole.trace(this + " >>> #" + delayBefore);
      while(Time.oClock() < t0)
        ControlThread.goSleepy();
    }
    return t0;
  }

  public String toString(){
    return desc.toString();
  }
  
  /**
   * Should throw an exception if this this instruction does not satisfy the function instructions' restrictions
   */
  void checkIfIsAllowedInFunction()throws ParseException{}
}

