
/* **********************************
 File:InstructionDescription.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 22.01.1999 21:52:18
 Comments: Part of the vIDE Project
***********************************/

package engine;
import java.io.Serializable;
/**
 * The description of an instruction (i.e. the instruction in terms of
 * uninstantiated stuff (symbol names, module description, etc.))
 */

public abstract class InstructionDescription implements Serializable {
    /**
     * the next instruction
     */
  public InstructionDescription next = null;
  int delayBefore = 0;
  
  /**
   * the NameSpace that contains this instruction
   */
  NameSpaceDescription nsd;

  /**
   * the line at wich this instruction is located
   */
  int line;

  InstructionDescription(int delayBefore, int line, NameSpaceDescription nsd){
    this.delayBefore = delayBefore;
    this.line = line;
    this.nsd = nsd;
  }
  
    /**
     * adds 'next' to this execution queue
     */
  void add(InstructionDescription next){
    this.next = next;
  }
  
  abstract Instruction instantiate(NameSpace ns)throws ParseException;

  public String toString(){
    return nsd.toString(line) + ":";
  }
}

