
/* **********************************
   File: IntSelector.java
   Author alec(alecu@kermit.cs.pub.ro)
   Created on: 21.03.1999 00:33:02
   Comments: Part of the vIDE Project
***********************************/

package engine;

class IntSelector extends Expression implements LeftValue{
    
  BitVector b;
  GenericSelectorDescription desc; //runtime type info
  
  public IntSelector(NameSpace n, BitVector b, GenericSelectorDescription desc){
    super(n);
    this.b = b;
    this.desc = desc;
    length = b.n;
  }
  
  public void addMonitor(Monitor m){
    b.addMonitor(m);
  }
  
  //TODO: de corectat: nu -si mareste lungimea dupa rezultat !
  public void assign(Result result)throws InterpretTimeException{
    BitVector val = result.getInt();
    if(length > val.n ) val.expandS(length);
    if(length < val.n ) val.trunc(length);
    try{
      b.attrib(val);
    }catch(Exception ex){
      if(xConsole.__debug__)ex.printStackTrace();
      throw new InterpretTimeException("invalid attribution: " + b + " = " + result);
    }
  }
  
  public Result evaluate(){
    return new BitVector(b);
  }
  
  public String toString(){
    return desc.toString();
  }

  public boolean isLeftValue(){
    return true;
  }

}
