
/* **********************************
 File:MonitorTask.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on May '99
 Comments:  Part of the vIDE Project
***********************************/

package engine;
import java.util.*;

/**
 * This is the BunchMonitor task activation instruction.
 * It simply creates a new BunchMonitor and attaches the DisplayTask to it.
 */

class MonitorTask extends DisplayTask {
  DisplayTask dt;
 
  MonitorTask(NameSpace m, int delayBefore, InstructionDescription desc,
              int defaultBase, Vector target, Instruction next){
    super(m, delayBefore, desc, defaultBase, target, next);
    Object o;
    this.defaultBase = defaultBase;
    add(next);
    this.target = new Vector();
    for (Enumeration e = target.elements(); e.hasMoreElements(); ) {
      o = e.nextElement();
      if (o != null && o instanceof Expression)
        this.target.addElement(o);
    }
    dt = new DisplayTask(this);
    dt.next = null;
  }

  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    xConsole.debug("starting bunchmonitor...");
    xConsole.trace("" + new BunchMonitor(ns, target, dt));
    if(next != null)next.execute();
  }
}






