
/* **********************************
 File:ParameterDescription.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on:06.03.1999 16:05:18
 Comments: Part of the vIDE Project
***********************************/

package engine;


import java.util.*;
import middle.*;

class ParameterDescription extends Symbol{

  ExpressionDescription ex;

  ParameterDescription(String name, int lineNo){
    super(name, lineNo);
    xConsole.debug("new parameter " + name);
  }

  void assign(ExpressionDescription ex){
    this.ex = ex;
  }
    
  public Object instantiate(NameSpace ns, ScopeNode thisScope)throws ParseException{
    try{
      Result r = ex.instantiate(ns).evaluate();
      return new Parameter(ns, this, r);
    }catch(Exception e){
      throw new ParseException(ns.desc.toString(lineNo) + " error:exception while evaluating parameter" + name);
    }
  }
  
  public String toString(){
    return name;
  }

  public int getType(){
    return paramType;
  }
}

