
/* **********************************
 File: RealDescription.java
 Author alec(alecu@kermit.cs.pub.ro)
 Created on: 20.03.1999 23:29:55
 Comments: Part of the vIDE Project
***********************************/

package engine;

import middle.*;

/**
 * The description of a Real reg
 */

class RealDescription extends Symbol implements MemoryDescription{

  public RealDescription(String name, int lineNo){
    super(name, lineNo);
  }

  Object instantiate(NameSpace ns, ScopeNode thisScope)throws ParseException{
    Real r = new Real();
    (new WatchMonitor(r, thisScope.addLeaf(Constants.realIcon, name, r))).trigger();
    VeriParser.historyManager.registerVariable(r, ns + "." + name);
    return r;
  }

  public int getType(){
    return realType; //correct ?
  }


  public int getArrayStart(){return 0;}
  public int getArrayEnd(){return 0;}
  
  public boolean isMemory(){return false;}

  public String toString(){
    return name;
  }
}








