
/* **********************************
 File: RealSelector.java
 Author alec(alecu@kermit.cs.pub.ro)
 Created on: 21.03.1999 00:33:02
 Comments: Part of the vIDE Project
***********************************/

package engine;

class RealSelector extends Expression implements LeftValue{
    
  Real r;
  GenericSelectorDescription desc;

  public RealSelector(NameSpace ns, Real r, GenericSelectorDescription desc){
    super(ns);
    this.r = r;
    this.desc = desc;
  }

  public void addMonitor(Monitor m){
    r.addMonitor(m);
  }

  public void assign(Result result)throws InterpretTimeException{
    try{
      r.attrib(result.getReal());
    }catch(Exception e){
      throw new InterpretTimeException("invalid attribution: " + r + " = " + r);
    }
  }

  public Result evaluate(){
    return new Real(r);
  }

  public String toString(){
    return desc.toString();
  }

  public boolean isLeftValue(){
    return true;
  }

}





