
/* **********************************
 File:RepeatInstruction.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 12:44:46
 Comments: Part of the vIDE Project
***********************************/

package engine;

class RepeatInstruction extends Instruction{
  Expression e;
  Instruction i;
  
  RepeatInstruction(NameSpace ns, int db, InstructionDescription desc,
                    Expression e, Instruction i, Instruction next){
    super(ns, db, desc);
    this.e = e;
    this.i = i;
    add(next);
  }

// self-explanatory
  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    xConsole.trace(toString() + "->");
    try { long lv = e.evaluate().getLong();
          while (lv > 0) { i.execute();  lv--; }
    } catch (Exception e) { }
    xConsole.trace("<-" + toString());
    if (next != null) next.execute();
  }
}
