/* **********************************
 File:RepeatInstructionDescription.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 12:26:00
 Comments: Part of the vIDE Project
***********************************/

package engine;

class RepeatInstructionDescription extends InstructionDescription{
  ExpressionDescription ed;
  InstructionDescription id;
  
  RepeatInstructionDescription(int delaybefore, int line, NameSpaceDescription nsd,
                               ExpressionDescription ed, InstructionDescription id){
    super(delaybefore, line, nsd);
    this.ed = ed;
    this.id = id;
  }
  
  Instruction instantiate(NameSpace ns)throws ParseException{
   
    Expression ex;
    try{
      ex = ed.instantiate(ns);
    }catch(ParseException exc){
      xConsole.dumpStack(exc);
      throw new ParseException(super.toString() + " error:" + exc);
    }

    return new RepeatInstruction(ns, delayBefore, this, ex,
      id.instantiate(ns), next == null ?  null : next.instantiate(ns));
  }

  public String toString(){
    return super.toString() + "repeat( " + ed + " )";
  }
}
