
/* **********************************
 File:SelectionExpressionDescription.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 12.02.1999 02:43:50
 Comments: Part of the vIDE Project
***********************************/

package engine;

import java.util.*;

class SelectionExpressionDescription implements ExpressionDescription,
                                                AssignableSelection{
  
  Vector chunks;
  
  SelectionExpressionDescription(){
    chunks = new Vector();
  }
  
  void addChunk(ChunkDescription ck){
    chunks.addElement(ck);
  }
  
  
  public Expression instantiate(NameSpace ns)throws ParseException{
    return new SelectionExpression(ns, chunks);
  }

  /**
   *  convert this to a wire assignable selection expression, 
   *  i.e converts all the 
   *  ChunkDecscriptions to ContChunkDescriptions
   */
  public void toContSelection()throws ParseException{
    Vector newChunks = new Vector();
      for(Enumeration e = chunks.elements() ; e.hasMoreElements() ;){
        newChunks.addElement(new
                             ContChunkDescription((ChunkDescription)
                                                  e.nextElement()));
      }
    chunks = newChunks;
  }

  public String toString(){
    String result = "{ ";
    Enumeration e = chunks.elements();
    while(true){
      result += ((ChunkDescription)e.nextElement());
      if(e.hasMoreElements())result += ", ";
      else break;
    }
    result += "}";
    return result;
  }

  public boolean isLeftValue(){
    return true;
  }

  Enumeration elements(){
    return chunks.elements();
  }

}




