
/* **********************************
 File:TaskInstruction.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 16:14:46
 Comments: Part of the vIDE Project
***********************************/

package engine;

import java.util.*;

class TaskInstruction extends Instruction{
  
  /**
   * The espressions of the actual parameters
   */
  Vector paramExps;
  Vector paramInstances;
  Instruction theTask;
  TaskDescription  taskDescription;

  TaskInstruction(int delayBefore, NameSpace  ns, InstructionDescription desc, TaskDescription taskDescription, 
                  Vector paramExps, Vector paramInstances,  Instruction theTask, Instruction next){
    super(ns, delayBefore, desc);
    this.taskDescription = taskDescription;
    this.paramExps = paramExps;
    this.paramInstances = paramInstances;
    this.next = next;
    this.theTask = theTask;
  }

  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    xConsole.trace(this + " |->");
    taskDescription.storeParamValues(paramExps, paramInstances);
    if(theTask != null)theTask.execute();
    taskDescription.fetchParamValues(paramExps, paramInstances);
    xConsole.trace(this + " <-|");
    if(next != null)next.execute();
  }

  public String toString(){
    return desc.toString();
  }
}



