
/* **********************************
 File:ValueChangeMonitorDescription.java
 Author: Alec(alecu@kermit.cs.pub.ro)
 Created on 12.02.1999 02:44:40
 Comments: Part of the vIDE Project
***********************************/

package engine;

class ValueChangeMonitorDescription extends MonitorDescription{
  
  int mask;
  
  ValueChangeMonitorDescription(NameSpaceDescription nsd, 
    ExpressionDescription target,int mask){
    super(nsd, target);
    this.mask = mask;
  }
  
  Monitor instantiate(NameSpace ns)throws ParseException{
    return new ValueChangeMonitor(ns, target.instantiate(ns), mask);
  }
 
  public String toString(){
    String result = " ";
    if((mask & ValueChangeMonitor.EVT_POSEDGE) != 0) result = "posedge ";
    else if((mask & ValueChangeMonitor.EVT_NEGEDGE) != 0) result = "negedge ";
    result += target;
    return result;
  }
}










