
/* **********************************
 File:WhileInstruction.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 12:44:46
 Comments: Part of the vIDE Project
***********************************/

package engine;

class WhileInstruction extends Instruction{
  Expression e;
  Instruction i;
  
  WhileInstruction(NameSpace ns, int db, InstructionDescription desc,
                   Expression e, Instruction i, Instruction next){
    super(ns, db, desc);
    this.e = e;
    this.i = i;
    add(next);
  }

// isTrue am bagat-o eu in BitVector... presupun ca se va folosi getBoolean()
// waitToRun() e in Instruction.java... include delayBefore-ul.
  public void execute()throws InterpretTimeException, SimulationStoppedException{
    waitToRun();
    xConsole.debug(toString());
    int k = 0;
    while (true){
      try{
        if(!e.evaluate().isTrue())break;
      }catch(InterpretTimeException ex){
        xConsole.dumpStack(ex);
        throw new InterpretTimeException(desc + ": error:" + ex);
      }
      i.execute();
      k++;
    }
    xConsole.trace("<-|" + toString() + ": " + k + " cycles performed");
    if (next != null) next.execute();
  }
}
