/* **********************************
 File:WhileInstructionDescription.java
 Author: Power(power@kermit.cs.pub.ro)
 Created on 22.03.1999 17:00:00
 Comments: Part of the vIDE Project
***********************************/

package engine;

class WhileInstructionDescription extends InstructionDescription{
  ExpressionDescription ed;
  InstructionDescription id;
  
  WhileInstructionDescription(int db, int line, NameSpaceDescription nsd,
                              ExpressionDescription ed, InstructionDescription id){
    super(db, line, nsd);
    this.ed = ed;
    this.id = id;
  }
  
  Instruction instantiate(NameSpace ns)throws ParseException{

    Expression ex;
    try{
      ex = ed.instantiate(ns);
    }catch(ParseException exc){
      xConsole.dumpStack(exc);
      throw new ParseException(super.toString() + " error:" + exc);
    }

    return new WhileInstruction(ns, delayBefore, this, ex, id.instantiate(ns),
      next == null ? null : next.instantiate(ns));
  }

  public String toString(){
    return super.toString() + "while( " + ed + " )";
  }
}




