/*    pentru VeriSim
 *    9 ianuarie '99
 *        Alec
 */

//this is a simple (the simplest !) way to interact with the user
//a GUI would be much appreciated !

package engine;

import java.io.*;
import middle.*;

public class xConsole {

  static boolean __debug__ = true;
  static boolean traceEnabled = true;
  static boolean tokenManagerTrace = false;

  protected static final int  COM_STEP = 0x00000010,
                              COM_UNIT = 0x00000100,
                              COM_GO   = 0x00001000,
                              COM_EXIT = 0x00010000,
                              CONSUMED = 0x00000001; //set if this command has been consumed
  protected static int command=COM_GO;

  static IOManager stdio = new DefaultIOManager();
  
  public static void setIOManager(IOManager io) {
    stdio = io;
  }
  
  public static void setRunMode(int com) {
    command = com;
  }

  public static synchronized void display(String s) {
    stdio.cout(s);
  }

  public static synchronized void cout(String s) {
    stdio.cout(s);
  }
  
  public static synchronized String cin() {
    return stdio.cin();
  }
  
  public static void debug(String s) {
    if (__debug__)System.out.println(s);
  }

  public static synchronized void trace(String s) {
    if (traceEnabled)stdio.cout(s);
  }

  public static void tokenMgrTrace(String s) {
    if (tokenManagerTrace)
      System.out.println(s);
  }

  public static void enableTracing(boolean traceEnabled) {
    xConsole.traceEnabled = traceEnabled;
  }

  static void abort(String s) {
    debug(s);
    abort();
  }

  static void abort(String s, Exception ex) {
    debug(s);
    cout("at:");
    ex.printStackTrace();
    abort();
  }
  
  static void abort() {
    debug("stack dump in abort():");
    Thread.dumpStack();
    stdio.abort();
  }

  static void dumpStack(Throwable th) {
    if (__debug__)th.printStackTrace();
  }
  
  public static synchronized void getCommand() {
    String s;
    while(true) {
      System.out.print("> ");
      s = cin();
      if ("step".startsWith(s)) {
        command = COM_STEP;
        break;
      }
      if ("go".startsWith(s)) {
        command = COM_GO;
        break;
      }
      if ("unit".startsWith(s)) {
        command = COM_UNIT;
        break;
      }
      if ("exit".startsWith(s)) {
        command = COM_EXIT;
        cout("By !");
        break;
      }
      if ("traceon".startsWith(s)) {
        xConsole.cout("Tracing is: on");
        xConsole.enableTracing(true);
        continue;
      }
      if ("traceoff".startsWith(s)) {
        xConsole.cout("Tracing is: off");
        xConsole.enableTracing(false);
        continue;
      }
      if ("debug".startsWith(s)) {
        xConsole.cout("debug is: " + (__debug__ =  !__debug__)); 
        continue;
      }
      if ("help".startsWith(s)) {
        cout("Available commands are:\n step\n go\n unit\n exit\n traceon\n traceoff\nEnjoy !");
      }else
        cout("huh ? try help");
    }
  }
  
  synchronized static  boolean enableExecution() {
     if ((command & CONSUMED) != 0)getCommand();
     return (command & COM_EXIT) == 0;
  }
  
  synchronized static void consumeStep() {
    if ( command == COM_STEP)command |= CONSUMED;
  }
  
  synchronized static void consumeUnit() {
    if (command == COM_UNIT)command |= CONSUMED;
  }
  
}




