/**
 *  About Dialog
*
* @author Lucian Felix Ghita 
* @version 1.0
* 01-03-99 
*/

package ide;


import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.plaf.*;
import javax.swing.text.*;
import javax.swing.tree.*;
import javax.swing.undo.*;
import javax.swing.text.html.*;


public class AboutDialog extends JDialog {

  public AboutDialog(JFrame f) {
    super(f, "About vIDE ", true);
    
    setResizable(false); 

    JTabbedPane tabs = new JTabbedPane(SwingConstants.TOP);


    JLabel imageLabel = new JLabel(new ImageIcon("images/splash.gif"));
    
    tabs.addTab( "About vIDE", null, imageLabel);


    JPanel infoPanel = new JPanel(new GridLayout(9, 1, 0, 0));
    java.util.Properties  properties;

    try
    {
        properties = System.getProperties();
        infoPanel.add(new JLabel("Operating system :" + properties.getProperty("os.name")));
        infoPanel.add(new JLabel("OS version :" + properties.getProperty("os.version")));
        infoPanel.add(new JLabel("os.architecture : " + properties.getProperty("os.arch")));
        infoPanel.add(new JLabel("java.vm.name :" + properties.getProperty("java.vm.name")));
        infoPanel.add(new JLabel("java.vm.info :" + properties.getProperty("java.vm.info")));
        infoPanel.add(new JLabel("java.vm.version :" + properties.getProperty("java.vm.version")));
        infoPanel.add(new JLabel("java.version :" + properties.getProperty("java.version")));
        infoPanel.add(new JLabel("JIT compiler :" + properties.getProperty("java.compiler")));
        infoPanel.add(new JLabel("Java Class Version :" + properties.getProperty("java.class.version")));
    } catch(SecurityException ex) {
        infoPanel.add(new JLabel("Security Excpetion: Cannot access System.getProperties()"));
    } 

    tabs.addTab( "Sys Info", null, infoPanel);
    
    JPanel aboutUsPanel = new JPanel(new GridLayout(15, 1, 0, 0));
    aboutUsPanel.add(new JLabel("vIDE - The Definitive Interplatform Verilog IDE(c) 1999 pChr"));
    aboutUsPanel.add(new JLabel("Copyright (c) 1999 - 0001"));
    aboutUsPanel.add(new JLabel(""));
    aboutUsPanel.add(new JLabel("Team:"));

    aboutUsPanel.add(new JLabel("Chief programmer: Alexandru Panoviciu"));
    aboutUsPanel.add(new JLabel(""));
    aboutUsPanel.add(new JLabel("Raluca Ionescu (ide) [ask the chief..]"));
    aboutUsPanel.add(new JLabel("Daniel Pavel (engine) [power@sundy.cs.pub.ro]"));
    aboutUsPanel.add(new JLabel("Alexandru Panoviciu (engine, middle) [alecu@sundy.cs.pub.ro]"));
    aboutUsPanel.add(new JLabel("Lucian Felix Ghita (ide, middle, artwork) [felix@sundy.cs.pub.ro]"));
    aboutUsPanel.add(new JLabel(""));   
    aboutUsPanel.add(new JLabel("made under the parental guidance of"));
    aboutUsPanel.add(new JLabel("\"Politehnica\" University of Buchrest, Romania( != Hungary ;-) "));
    aboutUsPanel.add(new JLabel("Computer Science Departament"));
    
    tabs.addTab( "Credits", aboutUsPanel);
    
    getContentPane().setLayout( new BorderLayout() );
    getContentPane().add(tabs, BorderLayout.CENTER);
    
    JButton ok = new JButton("OK");
    ok.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        OKPressed();
      }});
    JPanel p = new JPanel();
    p.setLayout( new BorderLayout() );
    p.add(ok, BorderLayout.EAST );
    getContentPane().add(p, BorderLayout.SOUTH );
    
    getRootPane().setDefaultButton(ok);
    pack();
    
    centerDialog();
  }

  protected void centerDialog() {
    Dimension screenSize = this.getToolkit().getScreenSize();
    Dimension size = this.getSize();
    screenSize.height = screenSize.height/2;
    screenSize.width = screenSize.width/2;
    size.height = size.height/2;
    size.width = size.width/2;
    int y = screenSize.height - size.height;
    int x = screenSize.width - size.width;
    this.setLocation(x,y);
  }

  public void OKPressed() {
    this.setVisible(false);
  }
}

