
package ide;

import java.util.*;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import javax.swing.event.*;
//import javax.swing.plaf.*;
//import javax.swing.text.*;
//import javax.swing.tree.*;
import javax.swing.undo.*;

import middle.*;
import engine.*;

class Project {
  
  public static final String PROJECT_EXTENSION = "vpr";
  
  protected ProjectView pv;       //referinta la ProjectView
  protected WatchView wv;         //to the bathrooom..
  protected BookmarksView bv;
  //chestie mishto frumos colorata cu butoane care merge fara 3DFX
  //nefolosita..
  public ConsoleView cv;          //referinta la consola
  protected int lastBookmark;     //not used.Err.. I don't know..
  protected VeriSimFrame god;     //Tatal Lor care e deasupra (Frame-ul aplicatiei)
  public VeriSimFrame.StatusBar sb;
  public WaveViewFrame waveViewFrame;
  public VeriSimDocumentFrame focusedEditor;  //editorul curent
  public boolean isValid;         //un proiect este incarcat
  public static EmptyIcon emptyIcon = new EmptyIcon(17, 17);   //o icoana plina cu goluri
  
  protected Hashtable files;      //fisierele incluse in proiect
  protected Hashtable editors;    //editoarele deschise
  protected Hashtable bookmarks;  //lacul cu prune
  protected String name;          //Bill Clinton
  //protected File directory;     //project directory //not used
  javax.swing.tree.DefaultMutableTreeNode watchTreeRoot;
  //public JProgressBar pb;       //not used
  public BusyFlag bf;             //shows an animation and a explanation for the current action
  public VCDReader vcdReader;     //folosit la WaveView
  //furnizeaza istoria variabilelor.
  
  //variabile folosite in operatia de cautare a unui text in editor
  public int fromWhereToFind = 0;
  public String textToFind = new String("BulaXYZ");
  //daca un fisier contzine BulaXYZ, cautarea va da gres... (pe bune!)
  
  
  ThreadGroup simulationThreadGroup = new ThreadGroup("Simulation");
  /*
  *  File actions
  */
  
  public AbstractAction newAction = new NewAction();
  public AbstractAction openAction = new OpenAction();
  public AbstractAction closeAction = new CloseAction();
  
  public AbstractAction newProjectAction = new NewProjectAction();
  public AbstractAction openProjectAction = new OpenProjectAction();
  public AbstractAction saveProjectAction = new SaveProjectAction();
  public AbstractAction closeProjectAction = new CloseProjectAction();
  public AbstractAction revertToSavedAction = new RevertToSavedAction();
  
  public AbstractAction addFilesToProjectAction = new AddFilesToProjectAction();
  public AbstractAction removeCurrentFileFromProject = new RemoveCurrentFileFromProject();
  
  public AbstractAction saveAction = new SaveAction();
  public AbstractAction saveAsAction = new SaveAsAction();
  public AbstractAction saveAllAction = new SaveAllAction();
  public AbstractAction quitAction = new QuitAction();
  
  
  /*
  *  Edit actions
  */
  
  public AbstractAction undoAction = new UndoAction();
  public AbstractAction redoAction = new RedoAction();
  
  public AbstractAction cutAction = new CutAction();
  public AbstractAction copyAction = new CopyAction();
  public AbstractAction pasteAction = new PasteAction();
  public AbstractAction deleteAction = new DeleteAction();
  public AbstractAction selectAllAction = new SelectAllAction();
  
  public AbstractAction findPreviousAction = new FindPreviousAction();
  public AbstractAction findNextAction = new FindNextAction();
  public AbstractAction findAction = new FindAction();
  public AbstractAction replaceAction = new ReplaceAction();
  public AbstractAction goToLineAction = new GoToLineAction();
  
  /*
  *  Window actions
  */
  
  public AbstractAction closeWindowAction = new CloseWindowAction();
  public AbstractAction closeAllWindowsAction = new CloseAllWindowsAction();
  
  public AbstractAction nextWindowAction = new NextWindowAction();
  public AbstractAction previousWindowAction = new PreviousWindowAction();
  
  
  public AbstractAction runAction = new RunAction();
  public AbstractAction stepAction = new StepAction();
  public AbstractAction stopAction = new StopAction();
  public AbstractAction goAction = new GoAction();
  public AbstractAction timeUnitAction = new TimeUnitAction();
  
  public AbstractAction openWaveSetAction = new OpenWaveSetAction();
  public AbstractAction saveWaveSetAction = new SaveWaveSetAction();
  
  
  
  /*
  * Standard constructor.
  *
  *
  *  Called only once by VeriSimFrame.
  *  When a new project is loaded via this.loadProject(), members will be reinitialized
  *  istead of reconstructing the whole class.
  */
  
  public Project(JFrame god) {
    vide.spl.showStatus("Creating project manager..");
    this.name = "no project ";
    isValid = false;
    this.god = (VeriSimFrame) god;   //the parent of all living stuff from here.
    //this.directory = null;           //remember to init this before use...
    files = new Hashtable();
    editors = new Hashtable();
    lastBookmark = 0;                //sa fie acolo.(nefolosit)
    bookmarks = new Hashtable();
    vide.spl.showStatus("Creating project manager..");
    bf = new BusyFlag();
    
    waveViewFrame = new WaveViewFrame(this);
    waveViewFrame.setVisible(false);
    ((VeriSimFrame)god).desktop.add(waveViewFrame, VeriSimFrame.DOCLAYER);
    bf.start();
    watchTreeRoot = new javax.swing.tree.DefaultMutableTreeNode();
    watchTreeRoot.setUserObject(new WatchTreeNode(watchTreeRoot, WatchTreeNode.PROJECTTYPE, name));
    //todo      //ce dracu am vrut sa fac aici?
    enableEditActions(false);
    
    
    vide.spl.showStatus("Done creating project manager.");
  }
  
  
  public void error(String s) {
    JOptionPane.showMessageDialog(god, "An error has ocured:\n" + s);
  }
  
  public boolean ask(String s) {
    Object[] options = { "OK", "CANCEL" };
    int selectedValue = JOptionPane.showOptionDialog(null, s, "Question!", JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null, options, options[0]);
    return selectedValue == 0;
  }
  
  public void newProject() {
    JFileChooser chooser = new JFileChooser("New project..");
    ExampleFileFilter filter = new ExampleFileFilter("vpr", "Verilog Project");
    chooser.setFileFilter(filter);
    int returnVal = chooser.showSaveDialog(god);
    if(returnVal != JFileChooser.APPROVE_OPTION) return;
    String fileName = chooser.getSelectedFile().getPath();
    
    if (fileName == null) return;  //cancel => user is undecided
    
    File file = new File(fileName);
    
    if (file.exists())
      if (!ask("A project with this name\n already exists.\nOverwrite?"))
        return; //cancel  again => the user is stupid
    int pindex = fileName.lastIndexOf('.');
    
    
    if (pindex == -1) fileName = fileName + ".vpr";
    //daca userul nu a pus extensie, o adaug eu.
    closeProject();   
    
    pindex = fileName.lastIndexOf('.');       
    //..ca sa o scot acum..
    
    this.name = fileName.substring(0, pindex);  //ihi scot extensia
    
    name = name.substring(name.lastIndexOf(java.io.File.separatorChar) + 1,name.length());
    //pastrez doar numele fisierului fara cale, fara extensie.
    
    
    god.setTitle(name + " - vIDE");
    isValid = true;
    
    files.clear();
    editors.clear();
    lastBookmark = 0;
    bookmarks.clear();
    
    //pv.empty();   //todo
    //bv.empty();
    //activateConsole();
    
    saveProject();
    updateProjectView();
    enableEditActions(true);
    enableProjectActions(true);
  }
  
        
  
  public void openProject() {
    
    JFileChooser chooser = new JFileChooser(".");
    ExampleFileFilter filter = new ExampleFileFilter(PROJECT_EXTENSION, "Verilog Project (" + PROJECT_EXTENSION + ")");
    chooser.setFileFilter(filter);
    int returnVal = chooser.showOpenDialog(god);
    if(returnVal != JFileChooser.APPROVE_OPTION) return;
    String file = chooser.getSelectedFile().getName();
    
    
    if (file == null) return; //the user is bored by this enviroment and make mistakes
    if (!(file.endsWith("." + PROJECT_EXTENSION))) {
      error("Could not load project.\nA VeriSim project file must have \n " + PROJECT_EXTENSION + " extension.");
      return;
    }
    
    try {
      FileInputStream fistream = new FileInputStream(file);   //name + "." + PROJECT_EXTENSION);
      ObjectInputStream oistream = new ObjectInputStream(fistream);
      if (!(((String) oistream.readObject()).equals("vIDE"))) {
        error("Could not load project.\nBad signature.");
        return;
      }
      
      String version = (String) oistream.readObject();
      //todo -> check if it's the right version
      name = (String) oistream.readObject();  //nume proiect
      files = (Hashtable) oistream.readObject();
      bookmarks = (Hashtable) oistream.readObject();
      
      fistream.close();
      
    } catch (Exception e) {
      System.out.println(e.toString());
      error("Project file not found.\n" + e);
    }
    isValid = true;   
    god.setTitle(name + " - vIDE");  
    updateProjectView();
    updateBookmarksView();
    cv.clear();
    //oistream.flush();
    enableEditActions(false);
    enableProjectActions(true);
    
    god.recentProjects.addName(chooser.getSelectedFile().getPath());
    god.refreshMRU(god.recentProjectsMenu, god.recentProjects); 
    //god.fHash.put("recentProjects", god.recentProjects);
    
    
  }
  
  public void saveProject() {
    try {
      FileOutputStream fostream = new FileOutputStream(name + "." + PROJECT_EXTENSION);
      ObjectOutputStream oostream = new ObjectOutputStream(fostream);
      oostream.writeObject("vIDE");        //signature
      oostream.writeObject(vide.PROJECT_VERSION);
      oostream.writeObject(name);  //nume proiect
      oostream.writeObject(files);
      oostream.writeObject(bookmarks);
      oostream.flush();
      fostream.close();
    } catch (Exception e) {
      error("Failed saving project with reason:\n" + e.toString());
      System.out.println("IOException : " + e);
    }
  }
  
  public void closeProject() {
    //enableEditActions(false);
    enableProjectActions(false);
    isValid = false;   
    //todo
    
    //pv.setProjectName(no project);
    pv.clear();
    wv.clear();
    files.clear();// = null; 
    bookmarks.clear();// = null;
    
    updateProjectView();
    
    pv.setEnabled(false);
    wv.setEnabled(false);
    

    god.setTitle("no project" + " - vIDE");
  }
  
  public void editProject() {
    //todo
    // ???  
  }
  public void go(String msg) {
    //BUG in swing: JFrame nu se prea descurca cu BusyCursor.
    //  ..poate fi ocolit asfel:
    //god.getGlassPane().setCursor(new Cursor(Cursor.WAIT_CURSOR));
    //degeaba..
    //todo: must register a listener for the glassPane 
    //  which will block the mouse messages for a while.
    //mai bine afisez o fereastra modala goala si de dimensiuni (0,0) !!!!!
    //nu merge pt. ca blocheaza threadul apelant..
    // se poate apela pe un thread nou..
    //in versiunea 2.0!
    sb.printStatus(msg);
    //bf.go();
  }
  public void stop() {
    //bf.end();
    sb.printStatus("Ready");
    //god.getGlassPane().setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    //todo -> restore cursor.
  }
  
  public void addFilesToProject() {
    
    JFileChooser chooser = new JFileChooser("Add file to project..");
    ExampleFileFilter filter = new ExampleFileFilter("v", "Verilog souce file");
    chooser.addChoosableFileFilter(filter);
    int returnVal = chooser.showOpenDialog(god);
    if(returnVal != JFileChooser.APPROVE_OPTION) return;
    String fileName = chooser.getSelectedFile().getPath();
    //Voi tzine minte calea completa la fiecare fisier inclus in proiect.
    File file = new File(fileName);
    if (!file.exists()) {
      error("File " + fileName + "not found");
      return;
    }
    
    files.put(fileName, new FileData(fileName));
    pv.addFile(fileName);
    pv.invalidate();
  }
  
  public void enableEditActions(boolean e) {
    undoAction.setEnabled(e);
    redoAction.setEnabled(e);
    cutAction.setEnabled(e);
    copyAction.setEnabled(e);
    pasteAction.setEnabled(e);
    deleteAction.setEnabled(e);
    selectAllAction.setEnabled(e);
    findPreviousAction.setEnabled(e);
    findAction.setEnabled(e);
    findNextAction.setEnabled(e);
    saveAction.setEnabled(e);
    saveAllAction.setEnabled (e);
    saveAsAction.setEnabled(e);     // de ce e comentata linia asta?
    closeAction.setEnabled(e);
    replaceAction.setEnabled(e);
    removeCurrentFileFromProject.setEnabled(e);
    revertToSavedAction.setEnabled(e);
    goToLineAction.setEnabled(e);
  }
  
  public void enableProjectActions(boolean e) {
    closeProjectAction.setEnabled(e);
    saveProjectAction.setEnabled(e);
    runAction.setEnabled(e);
    addFilesToProjectAction.setEnabled(e);
    wv.setEnabled(e);
  }
  
  public void addBookmark(String name) {
    //creates a text input dialog filled with "BookmarkX" where X = lastBookmark++
    //finds out the name of the active file and the current line and creates the value parameter
    if (focusedEditor == null) return;
    String fn = focusedEditor.getFileName();
    int ln = focusedEditor.getCurrentLine();
    String value = (fn + ":" +  ln);
    
    bookmarks.put(name, value);
  }
  
  public void removeBookmark(String name) {
    bookmarks.remove(name);
  }
  
  public void jumpToLocation(String fname, int lnumber) {
    VeriSimDocumentFrame doc = (VeriSimDocumentFrame)editors.get(fname);
    
    //check to see if the requested file is already open
    if(doc == null){
      doc = openFile(fname);
    }
    //doc.highlight(lnumber);  done in jumpToLine
    doc.jumpToLine(lnumber);
    doc.moveToFront();  //??
  }
  
  
  public void jumpToBookmark(String name) {
    String value = (String) bookmarks.get(name);
    String fname = value.substring(0, value.lastIndexOf(":"));
    int lnumber = Integer.parseInt(value.substring(value.indexOf(":")+1, value.length()));
    jumpToLocation(fname, lnumber);
    //todo bring to front.
  }
  
  public void revertToSaved() {
    if (!ask("Are you sure you want to reload \nlast saved version of \n" + focusedEditor.getFileName() + "?")) return;
    focusedEditor.loadFile(new File(focusedEditor.getFileName()));   
    
  }
  
  public void addToWindowsList(VeriSimDocumentFrame doc) {
    editors.put(doc.getFileName(), doc);
    //System.out.println(editors + "");
    //god.addToWindowsList(doc.getTitle());
    //todo -> update WindowsView
  }
  
  public void removeFromWindowsList(VeriSimDocumentFrame doc) {
    editors.remove(doc.getFileName());
    //todo -> update WindowsView
  }
  
  public VeriSimDocumentFrame openFile(String fn) {
    File f = new File(fn);
    //mai gandeshte-te..
    if (!f.exists()) {
      System.out.println(fn + "not found");
      return null;
    }
    VeriSimDocumentFrame doc = new VeriSimDocumentFrame(this, f);
    god.desktop.add(doc, VeriSimFrame.DOCLAYER);
    try {
      doc.setSelected(true);
      addToWindowsList(doc);
      god.recentFiles.addName(fn);
      god.refreshMRU(god.recentFilesMenu, god.recentFiles); 
      return doc;
    }
    catch (java.beans.PropertyVetoException e2) {
      System.out.println("Exception in openFile(String) :" + e2);
      return null;
    }
  }
  
  public void openFile() {
    JFileChooser chooser = new JFileChooser("Open file..");
    ExampleFileFilter vfilter = new ExampleFileFilter("v", "Verilog souce file");
    chooser.setFileFilter(vfilter);
    int returnVal = chooser.showOpenDialog(god);
    if(returnVal != JFileChooser.APPROVE_OPTION) return;
    String fileName = chooser.getSelectedFile().getPath();
    
    
    //String directory = fileDialog.getDirectory();  //todo  ???
    File f = new File(fileName);
    if (!f.exists()) return;   //the user or the Operating System is stupid
    //mai gandeshte-te..
    VeriSimDocumentFrame doc = new VeriSimDocumentFrame(this, f);
    god.desktop.add(doc, VeriSimFrame.DOCLAYER);
    try {
      doc.setSelected(true);
      editors.put(doc.getFileName(), doc);
      addToWindowsList(doc);
      god.recentFiles.addName(fileName);
      god.refreshMRU(god.recentFilesMenu, god.recentFiles); 
    }
    catch (java.beans.PropertyVetoException e2) {
      System.out.println("Exception in openFile() :" + e2);
    }
  }
  
  public void newFile() {
    VeriSimDocumentFrame doc = new VeriSimDocumentFrame(this, null);
    god.desktop.add(doc, VeriSimFrame.DOCLAYER);
    try {
      doc.setSelected(true);
      addToWindowsList(doc);
    } catch (java.beans.PropertyVetoException e2) {
      System.out.println("Exception :" + e2);
    }
  }
  
  public void updateBookmarksView() {
    for (Enumeration e = bookmarks.keys() ; e.hasMoreElements() ;) {
      //   (String)e.nextElement();  //todo
    }
  }
  
  public void updateProjectView() {
    pv.clear();
    DefaultTreeModel treeModel = (DefaultTreeModel) pv.projectTree.getModel();
    
    if (isValid)((ProjectTreeNode)((DefaultMutableTreeNode)((DefaultTreeModel) treeModel).getRoot()).getUserObject()).name = name;
    else ((ProjectTreeNode)((DefaultMutableTreeNode)((DefaultTreeModel) treeModel).getRoot()).getUserObject()).name = "No Project";
    
    treeModel = (DefaultTreeModel) wv.watchTree.getModel();
    
    if (isValid) ((WatchTreeNode)((DefaultMutableTreeNode)((DefaultTreeModel) treeModel).getRoot()).getUserObject()).name = name;
    else ((WatchTreeNode)((DefaultMutableTreeNode)((DefaultTreeModel) treeModel).getRoot()).getUserObject()).name = "No Project";
    
    pv.clear();
    for (Enumeration e = files.keys() ; e.hasMoreElements() ;) {
      pv.addFile((String)e.nextElement());
    }

    pv.invalidate();
    wv.invalidate();
    pv.repaint();
    wv.repaint();
  }
  
  public File selectFile() {
    FileDialog fileDialog = new FileDialog(god);
    fileDialog.setMode(FileDialog.LOAD);
    fileDialog.show();
    
    String file = fileDialog.getFile();
    if (file == null)
      return null; //no file selected
    
    String directory = fileDialog.getDirectory();
    File f = new File(directory, file);
    
    if (f.exists()) return f;
    else return null;
  }
  
  public void removeCurrentFileFromProject () {
    String name = getCurrentEditor().getFileName();
    files.remove(name);
    pv.removeFile(name);  //todo: nu merge!
    ((DefaultTreeModel) pv.projectTree.getModel()).nodeStructureChanged((DefaultMutableTreeNode) ((DefaultTreeModel) pv.projectTree.getModel()).getRoot());
    pv.invalidate();
    pv.repaint();
  }
  
  public VeriSimDocumentFrame getCurrentEditor() {  
    return focusedEditor;   //nu prea foloseshte/ focusedEditor e public shi valid tot timpul
    
  }
  
  public void saveAllFiles() {
    for (Enumeration e = editors.elements() ; e.hasMoreElements() ;) {
      ((VeriSimDocumentFrame)e.nextElement()).saveFile(null);
    }
  }
  
  
  /*
  *   Inner classes definitions
  *   All actions used all over. + some others
  *
  */
  
  
  class NewAction extends AbstractAction {
    public NewAction() {
      super("New");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/new.gif"));
      putValue(LONG_DESCRIPTION, "Creates a new file");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("New File...");
      newFile();
      stop();
    }
  }
  
  class AddFilesToProjectAction extends AbstractAction {
    public AddFilesToProjectAction() {
      super("Add file to project...");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Inserts existing file(s) into project");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Adding file...");
      addFilesToProject();
      stop();
    };
  }
  
  class OpenAction extends AbstractAction {
    public OpenAction() {
      super("Open...");setEnabled(true);
      putValue(SMALL_ICON,   new ImageIcon("images/open.gif"));
      putValue(LONG_DESCRIPTION, "Opens an existing document");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Opening file...");
      openFile();
      stop();
    };
  }
  
  class CloseAction extends AbstractAction {
    public CloseAction() {
      super("Close");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Closes the document");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      //todo closeFile();
    };
  }
  
  class SaveAction extends AbstractAction {
    public SaveAction() {
      super("Save");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/save.gif"));
      putValue(LONG_DESCRIPTION, "Saves the document");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      String fName = focusedEditor.getFileName();
      go("Saving " + fName);
      focusedEditor.saveFile(null);
      
      //fName = fName.substring(fName.lastIndexOf(java.io.File.separatorChar) + 1,fName.length());
      //updateProjectView();
      
      //pv.invalidate();
      //pv.repaint();
      
      if (files.containsKey(fName)) {
        //System.out.println("in if");    //never gets here!!!????
        //updateProjectView();
        pv.addFile(fName);
        pv.invalidate();
        pv.repaint();
      }
      stop();
    };
  }
  
  class SaveAsAction extends AbstractAction {
    public SaveAsAction() {
      super("Save As...");setEnabled(false);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Save the document with a new name");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Saving... " + focusedEditor.getFileName());
      
      JFileChooser chooser = new JFileChooser("Saving file with a different name..");
      ExampleFileFilter filter = new ExampleFileFilter("v", "Verilog souce file");
      chooser.addChoosableFileFilter(filter);
      int returnVal = chooser.showSaveDialog(god);
      if(returnVal != JFileChooser.APPROVE_OPTION) return;
      String fileName = chooser.getSelectedFile().getPath();
      
      File file = new File(fileName);
      
      if (file.exists())
        if (!ask("This file allready exist.\nOverwrite?")) {
          stop();
          return;
        }
        focusedEditor.saveFile(file);
      focusedEditor.setFileName(file.toString());
      stop();
      
      //trebuie sa bag fisierul in proiect in locul caluilalt?  //todo
      
    };
  }
  
  class SaveAllAction extends AbstractAction {
    public SaveAllAction() {
      super("SaveAll");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/saveAll.gif"));  
      putValue(LONG_DESCRIPTION, "Saves the document with a different name");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Saving all...");  //todo
      saveAllFiles();
      stop();
    };
  }
  
  class CutAction extends AbstractAction {
    public CutAction() {
      super("Cut");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/cut.gif"));
      putValue(LONG_DESCRIPTION, "Cuts the selected text.");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.editor.cut();
    };
  }
  
  class CopyAction extends AbstractAction {
    public CopyAction() {
      super("Copy");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/copy.gif"));
      putValue(LONG_DESCRIPTION, "Copy the selected text.");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.editor.copy();
    };
  }
  
  class PasteAction extends AbstractAction {
    public PasteAction() {
      super("Paste");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/paste.gif"));
      putValue(LONG_DESCRIPTION, "Paste the selected text.");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.editor.paste();
    };
  }
  
  class DeleteAction extends AbstractAction {
    public DeleteAction() {
      super("Delete");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/delete.gif"));
      putValue(LONG_DESCRIPTION, "Deletes the selected text.");
    }
    
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.editor.cut();
    };
  }
  
  class UndoAction extends AbstractAction {
    public UndoAction() {
      super("Undo");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/undo.gif"));
      putValue(LONG_DESCRIPTION, "Undoes the last action");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.undo();
    };
  }
  
  class RedoAction extends AbstractAction {
    public RedoAction() {
      super("Redo");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/redo.gif"));
      putValue(LONG_DESCRIPTION, "Redoes the previously undone action");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.redo();
    };
  }
  
  class SelectAllAction extends AbstractAction {
    public SelectAllAction() {
      super("Select All");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Selects the entire document");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      focusedEditor.editor.selectAll();
    };
  }
  
  
  class FindPreviousAction extends AbstractAction {
    public FindPreviousAction() {
      super("Find Previous");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/findprev.gif"));
      putValue(LONG_DESCRIPTION, "Finds the previous occurrence of the specified text");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      //todo ;
    };
  }
  
  class FindAction extends AbstractAction {
    public FindAction() {
      super("Find...");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/find.gif"));
      putValue(LONG_DESCRIPTION, "Find the specified text.");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Find...");
      
      String textToFindNow = JOptionPane.showInputDialog("Text to find:");
      
      if(!textToFind.equals(textToFindNow)){
        fromWhereToFind = 0;
        textToFind = textToFindNow;
        
      }
      
      int n = focusedEditor.editor.getText().indexOf(textToFind,fromWhereToFind);
      if(n == -1)return;
      fromWhereToFind = n + textToFind.length();
      focusedEditor.editor.select(n,n + textToFind.length());
      stop();
    };
  }
  
  class ReplaceAction extends AbstractAction {
    public ReplaceAction() {
      super("Replace");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Replaces the specified with different text");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      ReplaceDialog dialog = new ReplaceDialog(god, focusedEditor);
      dialog.setVisible(true);
    };
  }
  
  class GoToLineAction extends AbstractAction {
    public GoToLineAction() {
      super("Go to...");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Go to line number");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      GoToLineDialog dialog = new GoToLineDialog(god);
      dialog.setVisible(true);
      if (!dialog.isValid) return;
      String line = dialog.getLineNumber();
      try {
        int nline = Integer.parseInt(line);
        focusedEditor.jumpToLine(nline);
      } catch(Exception ex){   //input is not a number.
          return;
          };
    };
  }

  class FindNextAction extends AbstractAction {
    public FindNextAction() {
      super("Find Next");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/findnext.gif"));
      putValue(LONG_DESCRIPTION, "Finds the next occurrence of the specified text");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      
      int n = focusedEditor.editor.getText().indexOf(textToFind,fromWhereToFind);
      if (n == -1) {
        JOptionPane.showMessageDialog(god, "No more matches for specified text");
        fromWhereToFind = 0;
        return;
      }
      fromWhereToFind = n + textToFind.length();;
      focusedEditor.editor.select(n,n + textToFind.length());
    };
  }
  
  class SaveProjectAction extends AbstractAction {
    public SaveProjectAction() {
      super("Save project");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Saves the project");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Saving Project...");
      saveProject();
      stop();
    };
  }
  
  class NextWindowAction extends AbstractAction {
    public NextWindowAction() {
      super("Next");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/nextWindow.gif"));  //todo
      putValue(LONG_DESCRIPTION, "Activates the next editor window");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      //nextWindow();
    };
  }
  
  class PreviousWindowAction extends AbstractAction {
    public PreviousWindowAction() {
      super("Previous");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/previousWindow.gif"));  //todo
      putValue(LONG_DESCRIPTION, "Activates the next editor window.");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      //previousWindow();
    };
  }
  
  class CloseWindowAction extends AbstractAction {
    public CloseWindowAction() {
      super("Close");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);  //todo
      putValue(LONG_DESCRIPTION, "Closes the window");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      //closeWindow();
    };
  }
  
  class CloseAllWindowsAction extends AbstractAction {
    public CloseAllWindowsAction() {
      super("Close All");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);  //todo
      putValue(LONG_DESCRIPTION, "Closes all open windows");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      //closeAllWindow();
    };
  }
  
  class NewProjectAction extends AbstractAction {
    public NewProjectAction() {
      super("New Project...");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);  //todo
      putValue(LONG_DESCRIPTION, "Creates a new project");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("New Project...");
      newProject();
      stop();
      runAction.setEnabled(true);
    }
  }
  
  class OpenProjectAction extends AbstractAction {
    public OpenProjectAction() {
      super("Open Project...");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Opens an existing project");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Opening Project...");
      openProject();
      stop();
      runAction.setEnabled(true);
    };
  }
  
  class CloseProjectAction extends AbstractAction {
    public CloseProjectAction() {
      super("Close Project");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Closes the project");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      go("Closing project...");
      closeProject();
      stop();
      runAction.setEnabled(false);
    }
  }
  
  class QuitAction extends AbstractAction {
    public QuitAction() {
      super("Exit");setEnabled(true);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Exit");
    }
    public void actionPerformed(java.awt.event.ActionEvent e) {
      god.quit();
    }
  }
  
  class RunAction extends AbstractAction {
    public RunAction() {
      super("Run");setEnabled(false);
      putValue(SMALL_ICON, new ImageIcon("images/run.gif"));
      putValue(LONG_DESCRIPTION, "Start interpreting the current project");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      
      cv.clear();
      int n=0;
      for(Enumeration e = files.keys() ; e.hasMoreElements() ; e.nextElement(), n++);
      String[] arguments =new String[n+1];
      arguments[0] = "-sd";
      n = 1;
      for(Enumeration e = files.keys(); e.hasMoreElements();
        arguments[n++] = new String((String)e.nextElement()))
        
        System.out.println("Launching interpreter with arguments:" + arguments);
      (new Execute(simulationThreadGroup, arguments)).start();
      vcdReader = VeriParser.getVCDReader();
      //bag din nou veriabilele ramase, da' le schimb historyu' cu ocazia asta
      Object[] waveTargets; //numele variabilelor din waveViewFrame
      waveTargets = waveViewFrame.reset();
      for(int i = 0; i < waveTargets.length ; i++){
        wv.addWaveForm((String)waveTargets[i]);
      }
    }
  }
  
  public class Execute extends Thread {  //de ce se cheama Execute shi nu ExecuteAction? (alec) 
    String[] arguments;                  //deaia ca nu e actiune(felix) 
    public Execute(ThreadGroup tg, String[] arguments) {             //hainumannebuni !
      super(tg, "Execute");
      this.arguments = arguments;
    }
    
    public void run() {
      enableProjectActions(false);
      enableEditActions(false);
      runAction.setEnabled(false); //todo: more arguments.
      stepAction.setEnabled(true);
      timeUnitAction.setEnabled(true);
      goAction.setEnabled(true);
      go("Busy");
      saveWaveSetAction.setEnabled(false);
      openWaveSetAction.setEnabled(false);
      //todo
      VeriParser.runParser(arguments, (ScopeNode)(watchTreeRoot.getUserObject()), waveViewFrame.waveView, cv);
      
      enableProjectActions(true);
      saveWaveSetAction.setEnabled(true);
      openWaveSetAction.setEnabled(true);
      //enableEditActions(false);
      
      stepAction.setEnabled(false);
      timeUnitAction.setEnabled(false);
      goAction.setEnabled(false);
      runAction.setEnabled(true);
    }
  }
  
  class StepAction extends AbstractAction {
    public StepAction() {
      super("Step");setEnabled(false);
      putValue(SMALL_ICON, new ImageIcon("images/step.gif"));
      putValue(LONG_DESCRIPTION, "Executes one time step");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      cv.commandDispatch("step");
    }
  }
  
  class StopAction extends AbstractAction {
    public StopAction() {
      super("Stop");setEnabled(false);
      putValue(SMALL_ICON, new ImageIcon("images/stop.gif"));
      putValue(LONG_DESCRIPTION, "Stop interpretor");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      cv.commandDispatch("stop");
    }
  }
  
  class GoAction extends AbstractAction {
    public GoAction() {
      super("Go");setEnabled(false);
      putValue(SMALL_ICON, new ImageIcon("images/go.gif"));
      putValue(LONG_DESCRIPTION, "Free to go..Never stops..");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      cv.commandDispatch("go");
      
      stepAction.setEnabled(false);
      timeUnitAction.setEnabled(false);
      goAction.setEnabled(false);
      runAction.setEnabled(false);
      
    }
  }
  
  class TimeUnitAction extends AbstractAction {
    public TimeUnitAction() {
      super("TimeUnit");setEnabled(false);
      putValue(SMALL_ICON, new ImageIcon("images/timeUnit.gif"));
      putValue(LONG_DESCRIPTION, "Executes one time unit");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      cv.commandDispatch("go");
    }
  }
  
  class RemoveCurrentFileFromProject extends AbstractAction {
    public RemoveCurrentFileFromProject() {
      super("Remove Current File From Project ");setEnabled(false);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Removes current file from project.");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      removeCurrentFileFromProject();
    }
  }
  
  class RevertToSavedAction extends AbstractAction {
    public RevertToSavedAction() {
      super("Revert To Saved");setEnabled(false);
      putValue(SMALL_ICON, emptyIcon);
      putValue(LONG_DESCRIPTION, "Loads the last saved version of the saved file");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      revertToSaved();
    }
  }
  
  class OpenWaveSetAction extends AbstractAction {
    public OpenWaveSetAction() {
      super("Open WaveSet");setEnabled(true);
      putValue(SMALL_ICON, new ImageIcon("images/timeUnit.gif"));
      putValue(LONG_DESCRIPTION, "Loads a previously saved WaveSet");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      waveViewFrame.openWaveSet();
    }
  }
  
  class SaveWaveSetAction extends AbstractAction {
    public SaveWaveSetAction() {
      super("Save WaveSet");setEnabled(false);
      putValue(SMALL_ICON, new ImageIcon("images/timeUnit.gif"));
      putValue(LONG_DESCRIPTION, "Saves the current WaveSet");
    }
    public void actionPerformed(java.awt.event.ActionEvent event) {
      waveViewFrame.saveWaveSet();
    }
  }
}
/**
*   Describes a file included in project.
* todo
*/

class FileData implements Serializable {
  public String name;
  public boolean isReadOnly;
  public boolean isOpenedInEditor;
  public boolean isModified;
  public VeriSimDocumentFrame editor;
  
  public FileData(String name ) {
    this.name = name;
    isModified = false;
    isReadOnly = false;
    isOpenedInEditor = false;
  }
}

class BusyFlag extends Thread {
  private boolean go;
  public JProgressBar pb;
  private int direction  = 2;
  private int val = 0;
  
  public BusyFlag() {
    super();
    vide.spl.showStatus("Creating busy flag..");
    
    go = false;
  }
  
  public void run() {
    while(true) {
      try {sleep(1000);} catch (Exception e) {}
      while (go) {
        try {sleep(150);} catch (Exception e) {}
        val += direction;
        if ((val >= 40) || (val <= 0))
          direction = -direction;
        pb.setValue(val);
      }
      pb.setValue(val = 0);
    }
  }
  
  public void go() {
    val = 0;
    go = true;
    interrupt();
  }
  
  public void end() {
    go = false;
    interrupt();
  }
  
}
