
package ide;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.net.URL;
import java.util.*;

import javax.swing.text.*;
import javax.swing.undo.*;
import javax.swing.event.*;
import javax.swing.*;
import javax.swing.plaf.*;

/**
 * Sample JInternalFrame using the simple text editor component that
 * supports only one font. (for now)
 *
 * @author  Lucian Felix Ghita
 * @bugfixes Alec
 * @alecfixes fEliX
 * @version 1.0
 */
class VeriSimDocumentFrame extends JInternalFrame implements UndoableEditListener {

    private static int editorCount = 1;
    private static ResourceBundle resources;
    private Document theDocument;
    private String fileName;
    private Project theProject;  //null means that this file is not included in the current project
    private JScrollPane scroller;
    private int fontHeight;
    public boolean focused;

    public VerilogTextArea editor;
    private Hashtable commands;
    private Hashtable menuItems;
    private JMenuBar menubar;
    private JToolBar toolbar;
    private JComponent status;
    
    public NumberedBorder numberedBorder;


    /** UndoManager that we add edits to.  */
    protected UndoManager undo = new UndoManager();

    private UndoAction undoAction = new UndoAction();
    private RedoAction redoAction = new RedoAction();



    VeriSimDocumentFrame(Project project, File file) {

      super("New editor frame", true, true, true, true);
      this.theProject = project;

      //set the appropriate UI for editor:
      //veriLogTextUI is the UI class ID for UIDefaults
      UIManager.put(VerilogTextArea.uiClassID, "ide.VerilogTextUI"); 

      //focused = true;
      //open existing file or creates a new file if file == null;
      initEditor();

      if (file == null) {//new file
        setTitle("Untitled" + editorCount + ".v");
        fileName = "Untitled" + editorCount + ".v";
        editorCount++;
        return;
      }
      if (file.exists()) {
        setTitle("" + file);
        fileName = "" + file;
        editor.setDocument(loadFile(file));
        editor.getDocument().addUndoableEditListener(this); // Add this as a listener for undoable edits.
      }
    }
/* sa-l ia dracu' de JIT  compiler.Crapa mashina virtuala cu totul! (GPF in Msvcrt.dll sau in Kernel32.dll)
JAVA caused an invalid page fault in module KERNEL32.DLL at 014f:bff85fe2.
Registers:
EAX=c00211fc CS=014f EIP=bff85fe2 EFLGS=00010202
EBX=00000000 SS=0157 ESP=01ca0000 EBP=01ca0098
ECX=c00211f8 DS=0157 ESI=01ca00cc FS=3867
EDX=c00211fc ES=0157 EDI=01ca00b0 GS=0000
Bytes at CS:EIP: 56 8b 19 57 8b 30 55 83 7e 54 00 0f 84 1c 01 00
Stack dump: 00000000 00000000 bff85812 00000001 0000000e 01ca00b0 01ca00cc 81572840 8156a1bc 00000000 00000000 00000000 00000000 00000000 00000000 00000000
*/

    private void initEditor() {
      //editor.setFont(new Font("FixedSys", Font.PLAIN, 12));  //e cumva prea mult 12 ?
      //todo -> the font should be chosed from the preferences dialog from the getFontList() list;
      scroller = new JScrollPane(editor = new VerilogTextArea());
      JViewport vport = scroller. getColumnHeader();
      getContentPane().add("Center", scroller);
      setSize( 325, 200);
      setLocation( 20 + editorCount * 20, 55 + editorCount * 20);
      fontHeight = editor.getFont().getSize();  //shi cu spatiile dintre linii ce fac?
      addInternalFrameListener(new EditorInternalFrameAdapter(this, theProject));
      editor.getCaret().addChangeListener(new CaretPositionChangeListener(theProject.sb, editor)); 
      editor.getCaret().setBlinkRate(0);
        //fara blink scap de repainturi la tot editorul..!
      editor.setBorder(numberedBorder = new NumberedBorder(35, scroller.getViewport(), editor.getRowHeight()));
      setCursor(new Cursor(Cursor.TEXT_CURSOR));

      //din motive necunoscute (*#!?) JTextArea.getRowHeight() nu e publica..;
      //deci nu pot afla inaltimea unei linii,
      //ceea ce e un lucru foarte frustrant la ora 5 am...
    }



    public PlainDocument loadFile(File f) {
      try {

        //theProject.sb.printStatus("Loading file: " + f);
        PlainDocument doc = new PlainDocument();

        Reader in = new FileReader(f);
        char[] buff = new char[4096];
        int nch;
        
        while ((nch = in.read(buff, 0, buff.length)) != -1)
          doc.insertString(doc.getLength(), new String(buff, 0, nch), null);

        theProject.sb.printStatus("Done loading file: " + f);
        return doc;
      } catch (IOException e) {
        System.err.println("IOException opening file:" + e.toString());
        return null;
      } catch (BadLocationException e) {
        System.err.println("BadLocationException opening file:" +e.getMessage());
        return null;
      }
    } //loadFile()

    public void saveFile(File file) {
      //todo
      try { 
        PlainDocument doc = (PlainDocument) editor.getDocument();
        if (file == null) file = new File(fileName);   //save 
        else setFileName("" + file);                   //save As
            //todo -> scoate din editors, pne in editors.
        DataOutputStream fos = new DataOutputStream(new FileOutputStream(file));
        fos.writeBytes(doc.getText(0, doc.getLength()));   //todo nu e prea corect.
        fos.close();
      } catch (Exception e) {
        System.out.println("Err saving file:" + e.toString());
        
        theProject.error("Error saving file:\n" + e);
      }                                     
    }

    public String getFileName() {
      return fileName;
    }


    public void setFileName(String fileName) {
      setTitle(this.fileName = fileName);
    }


    /**
     * Messaged when the Document has created an edit, the edit is
     * added to <undo>, an instance of UndoManager.
     */
    public void undoableEditHappened(UndoableEditEvent e) {
      undo.addEdit(e.getEdit());
      undoAction.update();
      redoAction.update();
    }

    public void jumpToLine(int line) {
      highlightLine(line-1);
      scroller.getViewport().setViewPosition(new Point(0, editor.getRowHeight() * (line-1)));
        //todo ! - > fontHeigth != lineHeigth 
    }

    public int getCurrentLine() {
      try {
        return editor.getLineOfOffset(editor.getCaretPosition());
      } catch (Exception e) {
        theProject.error("Internal error in \n VeriSimDocumentFrame.getCurrentLine :\n" + e);
        return 0; // sau mai bine null
      }
    }

    public void highlightLine(int line) {
      //todo; method for highlight in NumberedBorder
      numberedBorder.bulletPosition = line;
    }

    public void undo() {
       (new UndoAction()).actionPerformed(null);
    }

    public void redo() {
      (new RedoAction()).actionPerformed(null);
    }

  class UndoAction extends AbstractAction {
    //todo -> something wrong here.
    public UndoAction() {
      super("Undo");
      setEnabled(false);
    }

    public void actionPerformed(ActionEvent e) {
      try {
        undo.undo();
      } catch (CannotUndoException ex) {
        System.out.println("Unable to undo.");
        ex.printStackTrace();
      }
      update();
      redoAction.update();
    }
    protected void update() {
      if(undo.canUndo()) {
        setEnabled(true);
        putValue(Action.NAME, undo.getUndoPresentationName());
      }
      else {
        setEnabled(false);
        putValue(Action.NAME, "Undo");
      }
    }
  } //UndoAction class


  class RedoAction extends AbstractAction {
    public RedoAction() {
      super("Redo");
      setEnabled(false);
    }

    public void actionPerformed(ActionEvent e) {
      try {
        undo.redo();
      }
      catch (CannotRedoException ex) {
        System.out.println("Unable to redo.");
        ex.printStackTrace();
      }
      update();
      undoAction.update();
    }

    protected void update() {
      if(undo.canRedo()) {
        setEnabled(true);
        putValue(Action.NAME, undo.getRedoPresentationName());
      }
      else {
      setEnabled(false);
      putValue(Action.NAME, "Redo");
      }
    }
  }// class RedoAction 


  /**
  * Project.focusedEditor modifier.
  *
  */

  class EditorInternalFrameAdapter extends javax.swing.event.InternalFrameAdapter {
    protected Project prj;
    protected VeriSimDocumentFrame editor;

    public EditorInternalFrameAdapter(VeriSimDocumentFrame editor, Project prj) {
      this.prj = prj;
      this.editor = editor;
    }

    public void  internalFrameActivated(InternalFrameEvent ev ) {
      prj.focusedEditor = editor;
      prj.god.setTitle(prj.name + " - vide - [" + editor.fileName + " ]"  );
      editor.focused = true;
      prj.enableEditActions(true);
    }

    public void internalFrameClosing(InternalFrameEvent ev) {
      editor.focused = false;
      prj.editors.remove(editor.getFileName());
      //todo: remove listeners for that gc can do the job.
      prj.god.setTitle(prj.name + " - vide");
      prj.enableEditActions(false);
    }

    public void internalFrameDeactivated(InternalFrameEvent e) {
      prj.enableEditActions(false);
    }

  } //EditorInternalFrameAdapter class


  /**
  * Displays line numbers on the left of editor
  * todo -> must be a inner class of Project and alocated only once.
  */

  class NumberedBorder extends javax.swing.border.EmptyBorder {
    int fontHeight;
    int startHeight = 0;
    int left;
    int endHeight = 0;
    JViewport vport;
    public int bulletPosition = 1;
    
    public NumberedBorder(int left, JViewport vport, int fontHeight) {
      super(0, left, 0, 0);
      this.left = left;
      this.vport = vport;
      this.fontHeight = fontHeight;
    }
    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
      //bug >>  if (vport.getViewPosition().x > left + 5) return; //the border is not shown.
      
      startHeight = vport.getViewPosition().y;
      endHeight = vport.getExtentSize().height + startHeight;
      g.setColor(Color.lightGray);
      g.fillRect(0, startHeight, left, endHeight);
      g.setColor(Color.black);
      int j = startHeight / fontHeight;
      for (int i = (j +1) * fontHeight - fontHeight/2; i < endHeight + 25; i += fontHeight, j++){ //j++ ?? whadda bad dream !
        g.drawString(j +1 + "", 0, i + 3);
      }
      
      g.setColor(Color.red);
      g.drawOval(10, bulletPosition * fontHeight + 3, 10, 10);
    }

    void setFontHeight(int newH){
      fontHeight = newH;
    }
  }//NumberedBorder  class
  
  
   
  /**
  * Displays caret position in the status bar.
  * todo -> alocate only once. 
  */
  
  class CaretPositionChangeListener implements ChangeListener {
    VeriSimFrame.StatusBar sb;
    DefaultCaret _caret;
    JTextArea _editor;
    int line;
    
    public CaretPositionChangeListener(VeriSimFrame.StatusBar sb, JTextArea _editor) {
      this._caret = (DefaultCaret) _editor.getCaret();
      this._editor = _editor;
      this.sb = sb;
    }
    
    public void stateChanged(ChangeEvent event) {
      int offset = _caret.getDot();
      try {
        line =_editor. getLineOfOffset(offset);
        sb.setLnCol(line, offset - _editor.getLineStartOffset(line));
        if(!_caret.isVisible())_caret.setVisible(true);
      } catch (Exception e) {
        System.out.println("Exception in caretListener.stateChanged:" + e);
      }
    }
  }//CaretPositionChangeListener class
}//VeriSimDocumentFrame class
//sa le ia dracu' de acolade.


