/* Generated By:JavaCC: Do not edit this line. VeriParser.java */
package engine;

import java.io.*;
import java.util.*;
import middle.*;

public class VeriParser implements VeriParserConstants {

  static Hashtable moduleDescriptions;
  static ModuleDescription curModule;
  static ScopeNode root = new DummyWatchNode();
  static TopModule topModule;
  static boolean verbose = false;
  static HashSet instantiatedModules;
  static VeriParser parser;   // pt. SwitchTo

  public static Vector objPaths;
  public static Vector exportedModules;
  public static boolean export;
  public static final String topName = "@top";

  volatile public static DummyVCDReader historyManager = new DummyVCDReader();

  //true if a RuntimeHistoryManager has been created
  static boolean historyManagerAvailable = false;

  public static void runParser(String args[], ScopeNode root, TimeUnitChangeListener tucl, IOManager io){
    xConsole.debug("parser started");
    VeriParser.root = root;
    xConsole.setIOManager(io);

    //switch to IDE listener & historyManager
    historyManager = new RuntimeVCDReader(tucl);
//    

    main(args);
  }

  public static VCDReader getVCDReader(){
    while(!historyManagerAvailable)Thread.yield();
    return historyManager;
  }

  public static void main(String args[]){

    moduleDescriptions = new Hashtable();
    instantiatedModules = new HashSet();

    objPaths = new Vector();
    objPaths.addElement("./");
    objPaths.addElement("modules/");
    exportedModules = new Vector();

    int i=0;
    if(args.length !=0){
      //default switches:
      xConsole.__debug__ = false;
      verbose = false;
      xConsole.setRunMode(xConsole.COM_GO);
      export = false;

                        if(args[0].startsWith("-")){
                                i++;
                                //switches parsing:
                                if(args[0].indexOf("v") != -1){
          xConsole.cout("vIDE Verilog(R) simulator version 0.9Beta\n" +
                        "See the file COPYING for info about legal stuff");
        }
                                if(args[0].indexOf("s") != -1){
                                        //step-by step mode:
                                        xConsole.setRunMode(xConsole.COM_STEP);
                                }
        if(args[0].indexOf("d") != -1){
          //verbose mode
          xConsole.__debug__ = true;
        }
        if(args[0].indexOf("p") != -1){
          //debug parser
          verbose = true;
        }
        if(args[0].indexOf("t0") != -1){
          //trace enable/disable
          xConsole.enableTracing(false);
        }
        if(args[0].indexOf("t1") != -1){
          //trace enable/disable
          xConsole.enableTracing(true);
        }
        if(args[0].indexOf("l") != -1){
          //dump objects
          export = true;
        }
        if(args[0].indexOf("h") != -1){
          //display help
          xConsole.cout("Usage : java engine.VeriParser [-v|s|d|p|h|t0|t1|l] [FILE]...\n" +
                        " v\t\tprints version & copyright\n" +
                        " s\t\tenters step-by-step mode\n" +
                        " d,p\t\tprints lots of ugly debug info's\n" +
                        " t1/t0\t\tenables/disables tracing\n" +
                        " l\t\tcreate object files with exported modules\n" +
                        " h\t\tprints this help message");
          return;
        }
                        }
    }
    if(i < args.length){   //some filenames are given...
      for(;i<args.length;i++){
        try{
          parser = new VeriParser(new FileReader(args[i]));
          if(verbose) {
            parser.enable_tracing();
            xConsole.tokenManagerTrace = true;
          } else {
            parser.disable_tracing();
            xConsole.tokenManagerTrace = false;
          }
          try{
            ParseException.currentFile = args[i];
            parser.start(args[i]);
          } catch ( ParseException ex){
            xConsole.dumpStack(ex);
            performCleanup();
            xConsole.cout(ex.getMessage());
            return;
          }
        } catch ( FileNotFoundException ex ){
          performCleanup();
          xConsole.cout("could not find file " + args[i]);
          return;
        }
      }
    }else{    //no file given at the command line(pipe or something ?)
      parser = new VeriParser(System.in);
      xConsole.cout("Reading from standard input:");
      try{
        parser.start("in");
      }catch(ParseException ex){
        xConsole.dumpStack(ex);
        performCleanup();
        xConsole.cout(ex.getMessage());
        return;
      }
    }
    try {
      try {
        xConsole.debug("checkin' up...");
        performCheckup();
        xConsole.debug("done");
      } catch (ParseException ex) {
          xConsole.dumpStack(ex);
          xConsole.cout(ex.getMessage());
          performCleanup();
          return;
      }
      if(export) {
        xConsole.debug("writing objects...");
        for(Enumeration e = exportedModules.elements() ; e.hasMoreElements() ;){
          String s = (String) e.nextElement();
          ModuleDescription md = (ModuleDescription) moduleDescriptions.get(s);
          if(md == null){
            throw new Error("error: exported module \"" + s + "\" not found");
          }
          xConsole.cout("writing \"" + s + ".vo\"");
          writeModule(md);
        }
        xConsole.debug("done");
      } else
        try {
          xConsole.debug("instantiating the stuff...");
          instantiateTheWholeStuff();
          historyManagerAvailable = true;  //moved here from runParser, because _here_ we can serve any VarHis request
          xConsole.debug("done");
          xConsole.debug("starting simulation");
          Time.addAfterFinish((DummyVCDReader)historyManager);
          Time.startSimulation();
          xConsole.debug("running simulation");
          Time.runSimulation();
          xConsole.debug("simulation ended");
          performCleanup();
        } catch (ParseException ex) {
          xConsole.dumpStack(ex);
          xConsole.cout(ex.getMessage());
          performCleanup();
          return;
        }
    } catch (Error err) {
      //if something went wrong, stop all the threads and make clean
      xConsole.debug("brrrr... ");
      xConsole.dumpStack(err);
      Time.stopSimulation();
      performCleanup();
      throw new Error("simulation error: " + err);
    }
  }

  /**
   * Resolves names to module descriptions
   */
  public static ModuleDescription getModuleByName(String name) {
    ModuleDescription res = (ModuleDescription) moduleDescriptions.get(name);
    if (res == null) {
      xConsole.debug("reading module \"" + name + "\"");
      res = readModule(name);
      if (res != null)
        moduleDescriptions.put(name, res);
    }
    return res;
  }

  /**
   * Finds a file that holds the given module,
   * using the paths from objPaths (assumed to end with '/')
   */
  public static String getModuleFile(String name) {
    for (Enumeration e = objPaths.elements() ; e.hasMoreElements() ; ) {
      String s = e.nextElement() + name + ".vo";
      if((new File(s)).exists()) return s;
    }
    return null;
  }

  /**
   * Fetches a ModuleDescription from a file.
   * The paths given in objPaths are searched for a match.
   * @return null if no filename matches the module name.
   */
  public static ModuleDescription readModule(String name) {
    String fileName = getModuleFile(name);
    ObjectInputStream oi = null;
    try {
      if (fileName != null) {
        return  (ModuleDescription)
          (oi = new ObjectInputStream(new FileInputStream(fileName))).
          readObject();
      }
    } catch (StreamCorruptedException scex) {
      throw new Error("error reading module \"" + fileName + "\". Bad data");
    } catch (IOException ioex) {
      throw new Error("IO exception while reading module \"" +
                      fileName + "\": " + ioex);
    }  catch (ClassNotFoundException cex){
      throw new Error(cex.toString());
    } finally {
      try {
        oi.close();
      } catch (IOException ioex) {}
    }
    return null;
  }

  /**
   * Dumps a moduleDescription to a file together with some magic &
   * ver info. The file is created into the current directory !
   */
  public static void writeModule(ModuleDescription desc) {
    ObjectOutputStream oo = null;
    String fileName = desc.name() + ".vo";
    try {
      oo = new ObjectOutputStream(new FileOutputStream(fileName));
      desc.breakLinks();
      oo.writeObject(desc);
    } catch (IOException ioex) {
      throw new Error("IO exception while writing module \"" +
                      fileName + "\": " + ioex);
    }
    finally {
      try {
        oo.close();
      } catch (IOException ioex) {}
    }
  }

  /**
   * this should nullify as many references as can get, 
   * in order to help gc
   */
  public static void performCleanup(){
    moduleDescriptions.clear();
    instantiatedModules.clear();
    exportedModules.clear();
    topModule = null;
    historyManagerAvailable = false;
    historyManager = null;
    parser = null;
    System.gc();
  }

  /**
   * this one fixes some stuff pending due to textual order or implicit conventions
   */
  public static void performCheckup()throws ParseException{
    for(Enumeration e = moduleDescriptions.elements() ; e.hasMoreElements() ; ){
      ((DefaultNameSpaceDescription)e.nextElement()).checkup();
    }
  }

  /**
   * this one will search for the "top" modules 
   * and instantiate them
   */
  public static void instantiateTheWholeStuff()throws ParseException{
    //this @top description contains instances of all the "top" modules
    int topCount = 0;
    ModuleDescription topDescription  = new ModuleDescription("none", 0, topName);
    for (Enumeration e = moduleDescriptions.keys(); e.hasMoreElements();){
      String name = (String)e.nextElement();
      if(((ModuleDescription)moduleDescriptions.get(name)).isTop()){
        //if it is top , create an implicit instance 
        //description with the same name as the desc.
        //into the topmost module
        topCount++;
        xConsole.debug("found top module: " + name);
        topDescription.addSubModule(name, 0, name, new Vector(), new Hashtable());
      }
    }
    topModule = new TopModule(topDescription);
    topModule.createInstances(root);
    if (topCount < 1) throw new ParseException("no top modules");
    xConsole.debug(topCount + " top module" + (topCount > 1 ? "s" : "") + " found");
  }

 // transform \t, \n. \ddd & \" in strings
  // for now, only used within the VeriParser, but...
  public static String stringTran(String s) throws ParseException{
    String result = "";
    int j;
    while (!s.equals("")) {
      j = s.indexOf('\\');
      if (j == -1) return result + s;
      if (j > 0) result += s.substring(0, j-1);
      char c = s.charAt(j+1);
      switch (c) {
        case '"':
        case '\\': result += c;  break;
        case 't': result += "\t";  break;
        case 'n': result += "\n";  break;
        case '0':
        case '1':
        case '2':
        case '3':
        case '4':
        case '5':
        case '6':
        case '7':
          int x = c - '0';
          for (int count = 0; count < 2 && j+2 < s.length(); count++) {
            c = s.charAt(j+2);
            if (c >= '0' && c <= '7') {
              j++;
              x = x << 3 + c - '0';
            }
          }
          result  = result + c; //simplu, dom'le !
            // uh... la faza asta... nu stiu.  (Power)
          break;
        default: throw new ParseException("Invalid escape sequence in string");
      }
      s = s.substring(j+2);
    }
    return result;
  }


  /**
   * Eliminates underscores from s.
   * (used for numbers)
   */
  public static String unUnderscore(String s){
    char [] cs = s.toCharArray();
    char [] cs1 = new char[cs.length];
    int i, j;
    for(i = j = 0 ; i < cs.length ; i++)
      if(cs[i] != '_')
        cs1[j++] = cs[i];
    return new String(cs1);
  }

/*
<UDP>
TOKEN [IGNORE_CASE] : {
  <EQUAL:           "=">
  <UDP_INITIAL:     ("1'b")? ["1","0"]>
}

<UDP,UDP_TABLE,UDP_STATE,DEFAULT>
TOKEN : {
    <COMMA:         ",">
  | <SEMICOLON:     ";">
  | <COLON:         ":">
  | <OBRACKET:      "(">
  | <CBRACKET:      ")">
}

<UDP_STATE>
TOKEN : [IGNORE_CASE] {
    <CLN:           ":"> : UDP_RESULT
  | <UDP_LEVEL:     ["1","0","x","?","b"]>
  | <UDP_EDGE:      ["r","f","p","n","*"]>
}

<UDP_RESULT>
TOKEN : [IGNORE_CASE] {
  <UDP_OUTPUT:      ["1","0","?","x","-"]>
  <SEMICLN:         ";"> : UDP_STATE
}
*/

////////////////////////////////////////////////////////////
//
// DONE WITH LEXICAL STUFF
//
//////////////////////////////////////////////////////////
  final public void start(String fileName) throws ParseException {
    trace_call("start");
    try {
  int line = 0;
      switch (jj_nt.kind) {
      case EXPORT:
        exportStatement();
        break;
      default:
        jj_la1[0] = jj_gen;
        ;
      }
      startModule(fileName);
    } finally {
      trace_return("start");
    }
  }

  final public void exportStatement() throws ParseException {
    trace_call("exportStatement");
    try {
  String s;
      jj_consume_token(EXPORT);
      jj_consume_token(145);
      label_1:
      while (true) {
        s = name();
                          exportedModules.add(s);
        switch (jj_nt.kind) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[1] = jj_gen;
          break label_1;
        }
      }
      jj_consume_token(146);
      jj_consume_token(147);
    } finally {
      trace_return("exportStatement");
    }
  }

////////////////////////////////////////////////////////
//
//          UDP STRUCTURE
//
/////////////////////////////////////////////////////////
/*
void startUdp(String fileName) :
{
  int line = 0;
  ProcAssignInstrucDescription paid;
  UdpTable ut;
  UdpDescription udp; 
}
{
  <PRIMITIVE> { line = token.beginLine; } name()
  {
    udp = new UdpDescription(fileName, line, token.image);
    moduleDescriptions.put(token.image, udp);
    xConsole.cout("parsing udp: " + token.image);
  }
  <OBRACKET> udpPortList(udp) <CBRACKET> <SEMICOLON>
  ((outputDeclare(udp) | inputDeclare(udp) | regDeclare(udp)) <SEMICOLON>)+
  [ <INITIAL> paid = udpAssign(udp) { udp.addInitial(paid); } ]
  ut = udpTable(udp) { udp.setTable(ut); }
  <ENDPRIMITIVE>
}

ProcAssignInstrucDescription udpAssign(UdpDescription nsd) :
{
  String image, reg;
  int line;
}
{
  name() { line = token.beginLine;  reg = token.image; }
  <EQUAL> <UDP_INITIAL>
  {
    image = (token.image.indexOf('\'') != -1 ? token.image.substring(3) : token.image);
  }
  <SEMICOLON>
  {
    return new ProcAssignInstrucDescription(0, line, nsd,
      new GenericSelectorDescription(reg, 0, 0, false),
      ConstantExpression.createNewUnsignedConstant(1, 2, image),
      0, false);
  }
}

void udpPortList(UdpDescription udp) : { }
{
  name() { udp.addPort(token.image, token.beginLine, Port.output); }
  <COMMA> name() { udp.addPort(token.image, token.beginLine, Port.input); }
  (<COMMA> name() { udp.addPort(token.image, token.beginLine, Port.input); })*
}

UdpTable udpTable(UdpDescription ud) :
{
  UdpTable td = new UdpTable(ud);
  EntryDescription ey;
}
{
  <TABLE>
  (
    (LOOKAHEAD(combinationalEntry(ud)) ey = combinationalEntry(ud) | ey = sequentialEntry(ud))
    <SEMICLN>
    { td.addEntry(ey); }
  )+
  <ENDTABLE>
  { return td; }
}

EntryDescription combinationalEntry(UdpDescription udp) :
{
  EntryDescription ey = new EntryDescription(udp);
}
{
  (levelItem(ey))+
  <COLON> <UDP_OUTPUT> { ey.setOutput(token.image); }
  {
    if (udp.isSequential)
      throw new ParseException("Illegal: combinational entry in sequential udp");
    return ey;
  }
}

EntryDescription sequentialEntry(UdpDescription udp) :
{
  EntryDescription ey = new EntryDescription(udp);
}
{
  (LOOKAHEAD(edgeList()) edgeList(ey) | (levelItem(ey))+)
  <COLON> <UDP_LEVEL> { ey.setCurrent(token.image); }
  <COLON> <UDP_OUTPUT>  { ey.setOutput(token.image); }
  {
    if (!udp.isSequential)
      throw new ParseException("Illegal: sequential entry in combinational udp");
    return ey;
  }
}

void edgeList(EntryDescription ey) :
{
  String s;
}
{
  (levelItem(ey))*
  ((<OBRACKET> <UDP_LEVEL> { s = token.image; } <UDP_LEVEL> { s += token.image; } <CBRACKET>)
  | (<UDP_EDGE> { s = token.image; }))
  { ey.add(s); }
  (levelItem(ey))*
}

void levelItem(EntryDescription ey) : {}
{
  <UDP_LEVEL> { ey.add(token.image); }
}

*/

////////////////////////////////////////////////////////
//
//            MODULE STRUCTURE
//
///////////////////////////////////////////////////////_
  final public void startModule(String fileName) throws ParseException {
    trace_call("startModule");
    try {
  int line = 0;
      label_2:
      while (true) {
        jj_consume_token(MODULE);
            line = token.beginLine;
        name();
    curModule = new ModuleDescription(fileName, line, token.image);
    moduleDescriptions.put(token.image, curModule);
    xConsole.cout("parsing module: "+token.image);
        switch (jj_nt.kind) {
        case 145:
          portList(curModule);
          break;
        default:
          jj_la1[2] = jj_gen;
          ;
        }
        jj_consume_token(147);
        label_3:
        while (true) {
          switch (jj_nt.kind) {
          case INPUT:
          case OUTPUT:
          case INOUT:
          case REG:
          case WIRE:
          case WAND:
          case WOR:
          case TRI:
          case TRIAND:
          case TRIOR:
          case TRIREG:
          case INTEGER:
          case REAL:
          case TIME:
          case REALTIME:
          case EVENT:
          case PARAMETER:
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[3] = jj_gen;
            break label_3;
          }
          moduleDeclare(curModule);
        }
        label_4:
        while (true) {
          switch (jj_nt.kind) {
          case INITIAL:
          case ALWAYS:
          case DEFPARAM:
          case ASSIGN:
          case TASK:
          case FUNCTION:
            ;
            break;
          default:
            jj_la1[4] = jj_gen;
            break label_4;
          }
          moduleItem(curModule);
        }
        jj_consume_token(ENDMODULE);
        switch (jj_nt.kind) {
        case MODULE:
          ;
          break;
        default:
          jj_la1[5] = jj_gen;
          break label_2;
        }
      }
    } finally {
      trace_return("startModule");
    }
  }

  final public void portList(NameSpaceDescription nsd) throws ParseException {
    trace_call("portList");
    try {
  int i = 0;
      jj_consume_token(145);
      portListItem(nsd, i++);
      label_5:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[6] = jj_gen;
          break label_5;
        }
        jj_consume_token(148);
        portListItem(nsd, i++);
      }
      jj_consume_token(146);
    } finally {
      trace_return("portList");
    }
  }

/**
 * Unlike the standard, we allow mixing of named/unnamed connections, but
 * we assign imlicit name <unnamed#0..> to the unnamed ones
 */
  final public void portListItem(NameSpaceDescription nsd, int i) throws ParseException {
    trace_call("portListItem");
    try {
  ExpressionDescription exd = null;
  int lineNo = 0;
  String name = "<unnamed#" + i + ">";
      if (jj_2_1(3)) {
        jj_consume_token(POINT);
        name = name();
                        lineNo = token.beginLine;
        jj_consume_token(145);
        switch (jj_nt.kind) {
        case POINT:
        case IDENTIFIER:
        case 154:
          exd = selectionExpression();
          break;
        default:
          jj_la1[7] = jj_gen;
          ;
        }
        jj_consume_token(146);
      } else {
        switch (jj_nt.kind) {
        case POINT:
        case IDENTIFIER:
        case 154:
          exd = selectionExpression();
       lineNo = token.beginLine;
       try{
         //if it's a single name, it is equivalent to a named port:
         GenericSelectorDescription gsd = (GenericSelectorDescription) exd;
         if (!gsd.hasLimits) {
           name = gsd.fqn;
           nsd.addPort(name, lineNo, PortDescription.none);
         }
       }catch(ClassCastException ex){}
          break;
        default:
          jj_la1[8] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    nsd.addConnection(name, lineNo, exd);
    } finally {
      trace_return("portListItem");
    }
  }

  final public void blockDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("blockDeclare");
    try {
      switch (jj_nt.kind) {
      case PARAMETER:
        paramDeclare(ns);
        break;
      case REG:
        regDeclare(ns);
        break;
      case INTEGER:
        integerDeclare(ns);
        break;
      case REAL:
        realDeclare(ns);
        break;
      case TIME:
        timeDeclare(ns);
        break;
      case REALTIME:
        realtimeDeclare(ns);
        break;
      case EVENT:
        eventDeclare(ns);
        break;
      default:
        jj_la1[9] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(147);
    } finally {
      trace_return("blockDeclare");
    }
  }

  final public void moduleDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("moduleDeclare");
    try {
      switch (jj_nt.kind) {
      case REG:
      case INTEGER:
      case REAL:
      case TIME:
      case REALTIME:
      case EVENT:
      case PARAMETER:
        blockDeclare(ns);
        break;
      case INPUT:
      case OUTPUT:
      case INOUT:
      case WIRE:
      case WAND:
      case WOR:
      case TRI:
      case TRIAND:
      case TRIOR:
      case TRIREG:
      case IDENTIFIER:
        switch (jj_nt.kind) {
        case WIRE:
        case WAND:
        case WOR:
        case TRI:
        case TRIAND:
        case TRIOR:
        case TRIREG:
          netDeclare(ns);
          break;
        case INPUT:
          inputDeclare(ns);
          break;
        case OUTPUT:
          outputDeclare(ns);
          break;
        case INOUT:
          inoutDeclare(ns);
          break;
        case IDENTIFIER:
          moduleInstanceDeclare(ns);
          break;
        default:
          jj_la1[10] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(147);
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("moduleDeclare");
    }
  }

  final public void moduleItem(NameSpaceDescription ns) throws ParseException {
    trace_call("moduleItem");
    try {
      switch (jj_nt.kind) {
      case FUNCTION:
        functionItem(ns);
        break;
      case TASK:
        taskItem(ns);
        break;
      case INITIAL:
        initialItem(ns);
        break;
      case ASSIGN:
        assignItem(ns);
        break;
      case ALWAYS:
        alwaysItem(ns);
        break;
      case DEFPARAM:
        defParamItem(ns);
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("moduleItem");
    }
  }

//_______________________________________
//
//           MODULE DECLARES
//_______________________________________
  final public void timeDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("timeDeclare");
    try {
  int lineNo;
      jj_consume_token(TIME);
         lineNo = token.beginLine;
    } finally {
      trace_return("timeDeclare");
    }
  }

  final public void realtimeDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("realtimeDeclare");
    try {
  int lineNo;
      jj_consume_token(REALTIME);
             lineNo = token.beginLine;
    } finally {
      trace_return("realtimeDeclare");
    }
  }

  final public void eventDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("eventDeclare");
    try {
  int lineNo;
      jj_consume_token(EVENT);
          lineNo = token.beginLine;
    } finally {
      trace_return("eventDeclare");
    }
  }

  final public void paramDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("paramDeclare");
    try {
  ExpressionDescription ex;
  String sym;
  int lineNo;
      jj_consume_token(PARAMETER);
      sym = name();
                ns.addParameter(sym, token.beginLine);
      switch (jj_nt.kind) {
      case 149:
        jj_consume_token(149);
        ex = expression();
     curModule.defParam(sym, ex);
        break;
      default:
        jj_la1[13] = jj_gen;
        ;
      }
    } finally {
      trace_return("paramDeclare");
    }
  }

  final public void realDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("realDeclare");
    try {
  String id;
      jj_consume_token(REAL);
      id = name();
   ns.addReal(id, token.beginLine);
      label_6:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[14] = jj_gen;
          break label_6;
        }
        jj_consume_token(148);
        id = name();
                  ns.addReal(id, token.beginLine);
      }
    } finally {
      trace_return("realDeclare");
    }
  }

  final public void integerDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("integerDeclare");
    try {
  String id;
  ExpressionDescription arrayStart = null, arrayEnd = null;
  int lineNo;
      jj_consume_token(INTEGER);
      id = name();
              lineNo = token.beginLine;
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        arrayStart = expression();
        jj_consume_token(151);
        arrayEnd = expression();
        jj_consume_token(152);
        break;
      default:
        jj_la1[15] = jj_gen;
        ;
      }
      ns.addInteger(id, lineNo, arrayStart, arrayEnd);
      arrayStart = arrayEnd = null;
      label_7:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[16] = jj_gen;
          break label_7;
        }
        jj_consume_token(148);
        id = name();
                lineNo = token.beginLine;
        switch (jj_nt.kind) {
        case 150:
          jj_consume_token(150);
          arrayStart = expression();
          jj_consume_token(151);
          arrayEnd = expression();
          jj_consume_token(152);
          break;
        default:
          jj_la1[17] = jj_gen;
          ;
        }
        ns.addInteger(id, lineNo, arrayStart, arrayEnd);
        arrayStart = arrayEnd = null;
      }
    } finally {
      trace_return("integerDeclare");
    }
  }

  final public void regDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("regDeclare");
    try {
  String id;
  int nStart = 0, nEnd = 0;
  ExpressionDescription  arrayStart = null , arrayEnd = null;
  ExpressionDescription msb = null, lsb = null;
  int lineNo;
      jj_consume_token(REG);
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        msb = expression();
        jj_consume_token(151);
        lsb = expression();
        jj_consume_token(152);
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      id = name();
              lineNo = token.beginLine;
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        arrayStart = expression();
        jj_consume_token(151);
        arrayEnd = expression();
        jj_consume_token(152);
        break;
      default:
        jj_la1[19] = jj_gen;
        ;
      }
      ns.addRegister(id, lineNo, msb, lsb, arrayStart, arrayEnd);
      arrayStart = arrayEnd = null;
      label_8:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[20] = jj_gen;
          break label_8;
        }
        jj_consume_token(148);
        id = name();
                lineNo = token.beginLine;
        switch (jj_nt.kind) {
        case 150:
          jj_consume_token(150);
          arrayStart = expression();
          jj_consume_token(151);
          arrayEnd = expression();
          jj_consume_token(152);
          break;
        default:
          jj_la1[21] = jj_gen;
          ;
        }
      ns.addRegister(id, lineNo, msb, lsb, arrayStart, arrayEnd);
      arrayStart = arrayEnd = null;
      }
    } finally {
      trace_return("regDeclare");
    }
  }

  final public void netDeclare(NameSpaceDescription nsd) throws ParseException {
    trace_call("netDeclare");
    try {
  String id;
  ExpressionDescription msb = null, lsb = null;
  int expandType = WireDescription.vectored; //the implicit is correct ??
  int lineNo;
  Delay3Description delays = Delay3Description.nullDelay;
  byte strength = Strength.defaultStrength;
  int netType = -1;
      switch (jj_nt.kind) {
      case WIRE:
      case WAND:
      case WOR:
      case TRI:
      case TRIAND:
      case TRIOR:
        switch (jj_nt.kind) {
        case WIRE:
        case TRI:
          switch (jj_nt.kind) {
          case WIRE:
            jj_consume_token(WIRE);
            break;
          case TRI:
            jj_consume_token(TRI);
            break;
          default:
            jj_la1[22] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                          netType = Assignable.typeWire;
          break;
        case WAND:
        case TRIAND:
          switch (jj_nt.kind) {
          case WAND:
            jj_consume_token(WAND);
            break;
          case TRIAND:
            jj_consume_token(TRIAND);
            break;
          default:
            jj_la1[23] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                              netType = Assignable.typeWand;
          break;
        case WOR:
        case TRIOR:
          switch (jj_nt.kind) {
          case WOR:
            jj_consume_token(WOR);
            break;
          case TRIOR:
            jj_consume_token(TRIOR);
            break;
          default:
            jj_la1[24] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                            netType = Assignable.typeWor;
          break;
        default:
          jj_la1[25] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch (jj_nt.kind) {
        case VECTORED:
        case SCALARED:
          switch (jj_nt.kind) {
          case VECTORED:
            jj_consume_token(VECTORED);
                 expandType = WireDescription.vectored;
            break;
          case SCALARED:
            jj_consume_token(SCALARED);
                                                                       expandType = WireDescription.scalared;
            break;
          default:
            jj_la1[26] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[27] = jj_gen;
          ;
        }
        if (jj_2_2(3)) {
          switch (jj_nt.kind) {
          case 145:
            strength = driveStrength();
            break;
          default:
            jj_la1[28] = jj_gen;
            ;
          }
          switch (jj_nt.kind) {
          case 150:
            jj_consume_token(150);
            msb = expression();
            jj_consume_token(151);
            lsb = expression();
            jj_consume_token(152);
            break;
          default:
            jj_la1[29] = jj_gen;
            ;
          }
          switch (jj_nt.kind) {
          case 153:
            delays = delay3(nsd);
            break;
          default:
            jj_la1[30] = jj_gen;
            ;
          }
          netDeclareWithAssignItem(nsd, msb, lsb, expandType, netType, delays, strength);
          label_9:
          while (true) {
            switch (jj_nt.kind) {
            case 148:
              ;
              break;
            default:
              jj_la1[31] = jj_gen;
              break label_9;
            }
            jj_consume_token(148);
            netDeclareWithAssignItem(nsd, msb, lsb, expandType, netType, delays,
                                               strength);
          }
        } else {
          switch (jj_nt.kind) {
          case IDENTIFIER:
          case 150:
          case 153:
            switch (jj_nt.kind) {
            case 150:
              jj_consume_token(150);
              msb = expression();
              jj_consume_token(151);
              lsb = expression();
              jj_consume_token(152);
              break;
            default:
              jj_la1[32] = jj_gen;
              ;
            }
            switch (jj_nt.kind) {
            case 153:
              delays = delay3(nsd);
              break;
            default:
              jj_la1[33] = jj_gen;
              ;
            }
            netDeclareItem(nsd, msb, lsb, expandType, netType, delays, strength);
            label_10:
            while (true) {
              switch (jj_nt.kind) {
              case 148:
                ;
                break;
              default:
                jj_la1[34] = jj_gen;
                break label_10;
              }
              jj_consume_token(148);
              netDeclareItem(nsd, msb, lsb, expandType, netType, delays,
                                       strength);
            }
            break;
          default:
            jj_la1[35] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      case TRIREG:
        jj_consume_token(TRIREG);
               netType = Assignable.typeTrireg;
        switch (jj_nt.kind) {
        case VECTORED:
        case SCALARED:
          switch (jj_nt.kind) {
          case VECTORED:
            jj_consume_token(VECTORED);
                 expandType = WireDescription.vectored;
            break;
          case SCALARED:
            jj_consume_token(SCALARED);
                                                                      expandType = WireDescription.scalared;
            break;
          default:
            jj_la1[36] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          break;
        default:
          jj_la1[37] = jj_gen;
          ;
        }
        switch (jj_nt.kind) {
        case 145:
          strength = chargeStrength();
          break;
        default:
          jj_la1[38] = jj_gen;
          ;
        }
        switch (jj_nt.kind) {
        case 150:
          jj_consume_token(150);
          msb = expression();
          jj_consume_token(151);
          lsb = expression();
          jj_consume_token(152);
          break;
        default:
          jj_la1[39] = jj_gen;
          ;
        }
        switch (jj_nt.kind) {
        case 153:
          delays = delay3(nsd);
          break;
        default:
          jj_la1[40] = jj_gen;
          ;
        }
        netDeclareItem(nsd, msb, lsb, expandType, netType, delays, strength);
        label_11:
        while (true) {
          switch (jj_nt.kind) {
          case 148:
            ;
            break;
          default:
            jj_la1[41] = jj_gen;
            break label_11;
          }
          jj_consume_token(148);
          netDeclareItem(nsd, msb, lsb, expandType, netType, delays,
                                  strength);
        }
        break;
      default:
        jj_la1[42] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("netDeclare");
    }
  }

  final public void netDeclareWithAssignItem(NameSpaceDescription nsd, ExpressionDescription msb, ExpressionDescription lsb,
                    int expandType, int netType,  Delay3Description delays, byte strength) throws ParseException {
    trace_call("netDeclareWithAssignItem");
    try {
  int lineNo;
  String id;
  ExpressionDescription rVal;
      id = name();
    lineNo = token.beginLine;
    nsd.addWire(id, lineNo, msb, lsb, expandType, netType, delays);
      switch (jj_nt.kind) {
      case 149:
        jj_consume_token(149);
        rVal = expression();
    SelectionExpressionDescription sed = new SelectionExpressionDescription();
    ChunkDescription c = new ChunkDescription(id);
    sed.addChunk(new ContChunkDescription(c, strength));
    nsd.addConnection(lineNo, sed, rVal, delays);
        break;
      default:
        jj_la1[43] = jj_gen;
        ;
      }
    } finally {
      trace_return("netDeclareWithAssignItem");
    }
  }

  final public void netDeclareItem(NameSpaceDescription nsd, ExpressionDescription msb, ExpressionDescription lsb,
                    int expandType, int netType,  Delay3Description delays, byte strength) throws ParseException {
    trace_call("netDeclareItem");
    try {
  int lineNo;
  String id;
      id = name();
    lineNo = token.beginLine;
    nsd.addWire(id, lineNo, msb, lsb, expandType, netType, delays);
    } finally {
      trace_return("netDeclareItem");
    }
  }

  final public void inputDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("inputDeclare");
    try {
  ExpressionDescription msb = null, lsb = null;
      jj_consume_token(INPUT);
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        msb = expression();
        jj_consume_token(151);
        lsb = expression();
        jj_consume_token(152);
        break;
      default:
        jj_la1[44] = jj_gen;
        ;
      }
      name();
     ns.addPort(token.image, token.beginLine, PortDescription.input, msb, lsb);
      label_12:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[45] = jj_gen;
          break label_12;
        }
        jj_consume_token(148);
        name();
     ns.addPort(token.image, token.beginLine, PortDescription.input, msb, lsb);
      }
    } finally {
      trace_return("inputDeclare");
    }
  }

  final public void outputDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("outputDeclare");
    try {
  ExpressionDescription msb = null, lsb = null;
      jj_consume_token(OUTPUT);
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        msb = expression();
        jj_consume_token(151);
        lsb = expression();
        jj_consume_token(152);
        break;
      default:
        jj_la1[46] = jj_gen;
        ;
      }
      name();
     ns.addPort(token.image, token.beginLine, PortDescription.output, msb, lsb);
      label_13:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[47] = jj_gen;
          break label_13;
        }
        jj_consume_token(148);
        name();
     ns.addPort(token.image, token.beginLine, PortDescription.output, msb, lsb);
      }
    } finally {
      trace_return("outputDeclare");
    }
  }

  final public void inoutDeclare(NameSpaceDescription ns) throws ParseException {
    trace_call("inoutDeclare");
    try {
  ExpressionDescription msb = null, lsb = null;
      jj_consume_token(INOUT);
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        msb = expression();
        jj_consume_token(151);
        lsb = expression();
        jj_consume_token(152);
        break;
      default:
        jj_la1[48] = jj_gen;
        ;
      }
      name();
     ns.addPort(token.image, token.beginLine, PortDescription.inout, msb, lsb);
      label_14:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[49] = jj_gen;
          break label_14;
        }
        jj_consume_token(148);
        name();
     ns.addPort(token.image, token.beginLine, PortDescription.inout, msb, lsb);
      }
    } finally {
      trace_return("inoutDeclare");
    }
  }

//note that this does not verify for corectness of
//the instantiation (the number of arguments, etc)
  final public void moduleInstanceDeclare(NameSpaceDescription nsd) throws ParseException {
    trace_call("moduleInstanceDeclare");
    try {
  String moduleName, descName;
  Vector portsVector = new Vector();
  Hashtable portsHash = new Hashtable();
  ExpressionDescription exp = null;
  int lineNo;
  String name;
      descName = name();
      moduleName = name();
                        lineNo = token.beginLine;
      switch (jj_nt.kind) {
      case 153:
        jj_consume_token(153);
        jj_consume_token(145);
        exp = expression();
        label_15:
        while (true) {
          switch (jj_nt.kind) {
          case 148:
            ;
            break;
          default:
            jj_la1[50] = jj_gen;
            break label_15;
          }
          jj_consume_token(148);
          exp = expression();
        }
        jj_consume_token(146);
        break;
      default:
        jj_la1[51] = jj_gen;
        ;
      }
      switch (jj_nt.kind) {
      case 145:
        jj_consume_token(145);
        if (jj_2_3(3)) {
          jj_consume_token(POINT);
          name = name();
                             lineNo = token.beginLine;
          jj_consume_token(145);
          switch (jj_nt.kind) {
          case POINT:
          case IDENTIFIER:
          case unsigned_number:
          case bin_number:
          case oct_number:
          case dec_number:
          case hex_number:
          case real_number:
          case ADD:
          case SUB:
          case LNEG:
          case BNEG:
          case BAND:
          case BOR:
          case BXOR:
          case BNAND:
          case BNOR:
          case BNXOR:
          case STRING:
          case 145:
          case 154:
            exp = expression();
            break;
          default:
            jj_la1[52] = jj_gen;
            ;
          }
                 portsHash.put(name, new ConnectionDescription (name,
                                                                lineNo,
                                                                exp));
          jj_consume_token(146);
          label_16:
          while (true) {
            switch (jj_nt.kind) {
            case 148:
              ;
              break;
            default:
              jj_la1[53] = jj_gen;
              break label_16;
            }
            jj_consume_token(148);
            jj_consume_token(POINT);
            name = name();
                                   lineNo = token.beginLine; exp = null;
            jj_consume_token(145);
            switch (jj_nt.kind) {
            case POINT:
            case IDENTIFIER:
            case unsigned_number:
            case bin_number:
            case oct_number:
            case dec_number:
            case hex_number:
            case real_number:
            case ADD:
            case SUB:
            case LNEG:
            case BNEG:
            case BAND:
            case BOR:
            case BXOR:
            case BNAND:
            case BNOR:
            case BNXOR:
            case STRING:
            case 145:
            case 154:
              exp = expression();
              break;
            default:
              jj_la1[54] = jj_gen;
              ;
            }
                   portsHash.put(name, new ConnectionDescription (name,
                                                                lineNo,
                                                                exp));
            jj_consume_token(146);
          }
        } else {
          switch (jj_nt.kind) {
          case POINT:
          case IDENTIFIER:
          case unsigned_number:
          case bin_number:
          case oct_number:
          case dec_number:
          case hex_number:
          case real_number:
          case ADD:
          case SUB:
          case LNEG:
          case BNEG:
          case BAND:
          case BOR:
          case BXOR:
          case BNAND:
          case BNOR:
          case BNXOR:
          case STRING:
          case 145:
          case 154:
            exp = expression();
                                portsVector.addElement(exp);
            label_17:
            while (true) {
              switch (jj_nt.kind) {
              case 148:
                ;
                break;
              default:
                jj_la1[55] = jj_gen;
                break label_17;
              }
              jj_consume_token(148);
              exp = expression();
                                                        portsVector.addElement(exp);
            }
            break;
          default:
            jj_la1[56] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(146);
        break;
      default:
        jj_la1[57] = jj_gen;
        ;
      }
      instantiatedModules.add(descName);
      nsd.addSubModule(moduleName, lineNo,
                      descName, portsVector, portsHash);
    } finally {
      trace_return("moduleInstanceDeclare");
    }
  }

//////////////////////////////////////////////
//
//           MODULE ITEMS
//
///////////////////////////////////////////////
  final public void functionItem(NameSpaceDescription nsd) throws ParseException {
    trace_call("functionItem");
    try {
  String name;
  int type;
  ExpressionDescription msb = null, lsb = null;
  FunctionDescription fd;
  InstructionDescription i;
  int line;
      jj_consume_token(FUNCTION);
              line = token.beginLine;
      switch (jj_nt.kind) {
      case REAL:
        jj_consume_token(REAL);
            type = Symbol.realType;
        break;
      case INTEGER:
        jj_consume_token(INTEGER);
               type = Symbol.intType;
        break;
      case 150:
        jj_consume_token(150);
        msb = expression();
        jj_consume_token(151);
        lsb = expression();
        jj_consume_token(152);
                                                       type = Symbol.regType;
        break;
      default:
        jj_la1[58] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      name = name();
      jj_consume_token(147);
   fd = type == Symbol.regType ? new FunctionDescription(nsd, name, line, msb, lsb) :
                                 new FunctionDescription(nsd, name, line, type);
      label_18:
      while (true) {
        switch (jj_nt.kind) {
        case INPUT:
        case REG:
        case INTEGER:
        case REAL:
        case TIME:
        case REALTIME:
        case EVENT:
        case PARAMETER:
          ;
          break;
        default:
          jj_la1[59] = jj_gen;
          break label_18;
        }
        switch (jj_nt.kind) {
        case REG:
        case INTEGER:
        case REAL:
        case TIME:
        case REALTIME:
        case EVENT:
        case PARAMETER:
          blockDeclare(fd);
          break;
        case INPUT:
          inputDeclare(fd);
          break;
        default:
          jj_la1[60] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(147);
      }
      i = instruction(fd);
                       fd.addInstruction(i);
      jj_consume_token(ENDFUNCTION);
    } finally {
      trace_return("functionItem");
    }
  }

  final public void taskItem(NameSpaceDescription nsd) throws ParseException {
    trace_call("taskItem");
    try {
  TaskDescription td;
  InstructionDescription i = null;
  String name;
      jj_consume_token(TASK);
      name = name();
      jj_consume_token(147);
   td = new TaskDescription(nsd, name, token.beginLine);
      label_19:
      while (true) {
        switch (jj_nt.kind) {
        case INPUT:
        case OUTPUT:
        case INOUT:
        case REG:
        case INTEGER:
        case REAL:
        case TIME:
        case REALTIME:
        case EVENT:
        case PARAMETER:
          ;
          break;
        default:
          jj_la1[61] = jj_gen;
          break label_19;
        }
        switch (jj_nt.kind) {
        case REG:
        case INTEGER:
        case REAL:
        case TIME:
        case REALTIME:
        case EVENT:
        case PARAMETER:
          blockDeclare(td);
          break;
        case INPUT:
        case OUTPUT:
        case INOUT:
          switch (jj_nt.kind) {
          case INPUT:
            inputDeclare(td);
            break;
          case OUTPUT:
            outputDeclare(td);
            break;
          case INOUT:
            inoutDeclare(td);
            break;
          default:
            jj_la1[62] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          jj_consume_token(147);
          break;
        default:
          jj_la1[63] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch (jj_nt.kind) {
      case BEGIN:
      case IF:
      case CASE:
      case CASEX:
      case CASEZ:
      case FOR:
      case WHILE:
      case REPEAT:
      case FORK:
      case DISPLAY:
      case DISPLAYB:
      case DISPLAYO:
      case DISPLAYH:
      case WRITE:
      case WRITEB:
      case WRITEO:
      case WRITEH:
      case MONITOR:
      case MONITORB:
      case MONITORO:
      case MONITORH:
      case STROBE:
      case STROBEB:
      case STROBEO:
      case STROBEH:
      case COUT:
      case FINISH:
      case POINT:
      case IDENTIFIER:
      case AT:
      case 147:
      case 153:
      case 154:
        i = instruction(td);
                        td.addInstruction(i);
        break;
      default:
        jj_la1[64] = jj_gen;
        ;
      }
      jj_consume_token(ENDTASK);
    } finally {
      trace_return("taskItem");
    }
  }

  final public void defParamItem(NameSpaceDescription ns) throws ParseException {
    trace_call("defParamItem");
    try {
  String sym;
  ExpressionDescription ex;
      jj_consume_token(DEFPARAM);
      sym = name();
      switch (jj_nt.kind) {
      case 149:
        jj_consume_token(149);
        ex = expression();
     ns.defParam(sym, ex);
        break;
      default:
        jj_la1[65] = jj_gen;
        ;
      }
    } finally {
      trace_return("defParamItem");
    }
  }

  final public void assignItem(NameSpaceDescription nsd) throws ParseException {
    trace_call("assignItem");
    try {
  SelectionExpressionDescription lVal;
  ExpressionDescription rVal;
  int lineNo;
  Delay3Description delays = Delay3Description.nullDelay;;
  byte strength = Strength.defaultStrength;
      jj_consume_token(ASSIGN);
      switch (jj_nt.kind) {
      case 145:
        strength = driveStrength();
        break;
      default:
        jj_la1[66] = jj_gen;
        ;
      }
      switch (jj_nt.kind) {
      case 153:
        delays = delay3(nsd);
        break;
      default:
        jj_la1[67] = jj_gen;
        ;
      }
      lVal = wireSelectionExpression(strength);
                                             lineNo = token.beginLine;
      jj_consume_token(149);
      rVal = expression();
     nsd.addConnection(lineNo, lVal, rVal, delays);
      label_20:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[68] = jj_gen;
          break label_20;
        }
        jj_consume_token(148);
        lVal = wireSelectionExpression(strength);
                                              lineNo = token.beginLine;
        jj_consume_token(149);
        rVal = expression();
       nsd.addConnection(lineNo, lVal, rVal, delays);
      }
      jj_consume_token(147);
    } finally {
      trace_return("assignItem");
    }
  }

/**
 * Trireg charge strength
 */
  final public byte chargeStrength() throws ParseException {
    trace_call("chargeStrength");
    try {
  byte strength = Strength.defaultTriregStrength;
      jj_consume_token(145);
      jj_consume_token(SMALL);
              strength = Strength.small;
      jj_consume_token(MEDIUM);
              strength = Strength.medium;
      jj_consume_token(LARGE);
              strength = Strength.large;
      jj_consume_token(146);
    {if (true) return Strength.getStrength(strength, strength);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("chargeStrength");
    }
  }

  final public byte driveStrength() throws ParseException {
    trace_call("driveStrength");
    try {
  byte s0, s1;
      jj_consume_token(145);
      switch (jj_nt.kind) {
      case SUPPLY0:
      case STRONG0:
      case PULL0:
      case WEAK0:
      case HIGHZ0:
        s0 = strength0();
        jj_consume_token(148);
        s1 = strength1();
        break;
      case SUPPLY1:
      case STRONG1:
      case PULL1:
      case WEAK1:
      case HIGHZ1:
        s1 = strength1();
        jj_consume_token(148);
        s0 = strength0();
        break;
      default:
        jj_la1[69] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(146);
   {if (true) return Strength.getStrength(s0, s1);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("driveStrength");
    }
  }

  final public byte strength1() throws ParseException {
    trace_call("strength1");
    try {
      switch (jj_nt.kind) {
      case SUPPLY1:
        jj_consume_token(SUPPLY1);
               {if (true) return Strength.supply;}
        break;
      case STRONG1:
        jj_consume_token(STRONG1);
               {if (true) return Strength.strong;}
        break;
      case PULL1:
        jj_consume_token(PULL1);
             {if (true) return Strength.pull;}
        break;
      case WEAK1:
        jj_consume_token(WEAK1);
             {if (true) return Strength.weak;}
        break;
      case HIGHZ1:
        jj_consume_token(HIGHZ1);
              {if (true) return Strength.highz;}
        break;
      default:
        jj_la1[70] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("strength1");
    }
  }

  final public byte strength0() throws ParseException {
    trace_call("strength0");
    try {
      switch (jj_nt.kind) {
      case SUPPLY0:
        jj_consume_token(SUPPLY0);
               {if (true) return Strength.supply;}
        break;
      case STRONG0:
        jj_consume_token(STRONG0);
               {if (true) return Strength.strong;}
        break;
      case PULL0:
        jj_consume_token(PULL0);
             {if (true) return Strength.pull;}
        break;
      case WEAK0:
        jj_consume_token(WEAK0);
             {if (true) return Strength.weak;}
        break;
      case HIGHZ0:
        jj_consume_token(HIGHZ0);
              {if (true) return Strength.highz;}
        break;
      default:
        jj_la1[71] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("strength0");
    }
  }

//the wire selection expression uses continuous assignement chunks
  final public SelectionExpressionDescription wireSelectionExpression(byte strength) throws ParseException {
    trace_call("wireSelectionExpression");
    try {
  SelectionExpressionDescription sed = new SelectionExpressionDescription();
  ChunkDescription c;
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
        c = chunk();
      try{
        sed.addChunk(new ContChunkDescription((ChunkDescription)c, strength));
      }catch(ClassCastException ex){
        xConsole.debug("ClassCastException!");
        {if (true) throw new ParseException("NonWire used on left hand in assignement !");}
      }
        break;
      case 154:
        jj_consume_token(154);
        c = chunk();
          try{
            sed.addChunk(new ContChunkDescription((ChunkDescription)c, strength));
          }catch(ClassCastException ex){
            {if (true) throw new ParseException("NonWire used on left hand in assignement !");}
          }
        label_21:
        while (true) {
          switch (jj_nt.kind) {
          case 148:
            ;
            break;
          default:
            jj_la1[72] = jj_gen;
            break label_21;
          }
          jj_consume_token(148);
          c = chunk();
          try{
            sed.addChunk(new ContChunkDescription((ChunkDescription)c, strength));
          }catch(ClassCastException ex){
            {if (true) throw new ParseException("NonWire used on left hand in assignement !");}
          }
        }
        jj_consume_token(155);
        break;
      default:
        jj_la1[73] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    {if (true) return sed;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("wireSelectionExpression");
    }
  }

  final public void initialItem(NameSpaceDescription nsd) throws ParseException {
    trace_call("initialItem");
    try {
  InstructionDescription i;
  int lineNo;
      jj_consume_token(INITIAL);
             lineNo = token.beginLine;
      i = instruction(nsd);
                                                               nsd.addInitial(i, lineNo);
    } finally {
      trace_return("initialItem");
    }
  }

  final public void alwaysItem(NameSpaceDescription nsd) throws ParseException {
    trace_call("alwaysItem");
    try {
  InstructionDescription i;
  int lineNo;
      jj_consume_token(ALWAYS);
           lineNo = token.beginLine;
      i = instruction(nsd);
                                                             nsd.addAlways(i, lineNo);
    } finally {
      trace_return("alwaysItem");
    }
  }

  final public InstructionDescription instruction(NameSpaceDescription nsd) throws ParseException {
    trace_call("instruction");
    try {
  InstructionDescription i = null;
  int delayBefore = 0;
  int line = 0;
      switch (jj_nt.kind) {
      case 153:
        delayBefore = delay();
        break;
      default:
        jj_la1[74] = jj_gen;
        ;
      }
      if (jj_2_4(2)) {
        i = begin(delayBefore, nsd);
      } else if (jj_2_5(2)) {
        i = procAssign(delayBefore, nsd);
      } else {
        switch (jj_nt.kind) {
        case DISPLAY:
        case DISPLAYB:
        case DISPLAYO:
        case DISPLAYH:
        case WRITE:
        case WRITEB:
        case WRITEO:
        case WRITEH:
        case MONITOR:
        case MONITORB:
        case MONITORO:
        case MONITORH:
        case STROBE:
        case STROBEB:
        case STROBEO:
        case STROBEH:
        case COUT:
          i = systemTask(delayBefore, nsd);
          break;
        case AT:
          i = atInstruction(delayBefore, nsd);
          break;
        case REPEAT:
          i = repeatInstruction(delayBefore, nsd);
          break;
        case IF:
          i = ifInstruction(delayBefore, nsd);
          break;
        case CASE:
        case CASEX:
        case CASEZ:
          i = caseInstruction(delayBefore, nsd);
          break;
        case FOR:
          i = forInstruction(delayBefore, nsd);
          break;
        case WHILE:
          i = whileInstruction(delayBefore, nsd);
          break;
        case FORK:
          i = forkInstruction(delayBefore, nsd);
          break;
        case POINT:
        case IDENTIFIER:
          i = taskEnableInstruction(delayBefore, nsd);
          break;
        case FINISH:
          i = finishTaskInstruction(delayBefore, nsd);
          break;
        case 147:
          jj_consume_token(147);
          break;
        default:
          jj_la1[75] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    line = token.beginLine;
    {if (true) return i == null ? new EmptyInstructionDescription(delayBefore, line, nsd) : i;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("instruction");
    }
  }

  final public InstructionDescription finishTaskInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("finishTaskInstruction");
    try {
      jj_consume_token(FINISH);
      switch (jj_nt.kind) {
      case 145:
        jj_consume_token(145);
        jj_consume_token(146);
        break;
      default:
        jj_la1[76] = jj_gen;
        ;
      }
      jj_consume_token(147);
    {if (true) return new FinishTaskDescription(delayBefore, token.beginLine, nsd);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("finishTaskInstruction");
    }
  }

  final public InstructionDescription systemTask(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("systemTask");
    try {
  xConsole.debug("systemTask");
  InstructionDescription i;
      switch (jj_nt.kind) {
      case DISPLAY:
      case DISPLAYB:
      case DISPLAYO:
      case DISPLAYH:
        i = displayTask(delayBefore, nsd);
        break;
      case COUT:
        i = coutTask(delayBefore, nsd);
        break;
      case WRITE:
      case WRITEB:
      case WRITEO:
      case WRITEH:
        i = writeTask(delayBefore, nsd);
        break;
      case STROBE:
      case STROBEB:
      case STROBEO:
      case STROBEH:
        i = strobeTask(delayBefore, nsd);
        break;
      case MONITOR:
      case MONITORB:
      case MONITORO:
      case MONITORH:
        i = monitorTask(delayBefore, nsd);
        break;
      default:
        jj_la1[77] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    {if (true) return i;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("systemTask");
    }
  }

  final public Vector expressionList() throws ParseException {
    trace_call("expressionList");
    try {
  Vector theList = new Vector();
  ExpressionDescription anExpression;
      anExpression = expression();
                                theList.addElement(anExpression);
      label_22:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[78] = jj_gen;
          break label_22;
        }
        jj_consume_token(148);
        anExpression = expression();
                                     theList.addElement(anExpression);
      }
   {if (true) return theList;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("expressionList");
    }
  }

  final public InstructionDescription taskEnableInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("taskEnableInstruction");
    try {
  String taskName;
  int line;
  Vector paramsList = null;
      taskName = fqName();
                       line = token.beginLine;
      jj_consume_token(145);
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
      case unsigned_number:
      case bin_number:
      case oct_number:
      case dec_number:
      case hex_number:
      case real_number:
      case ADD:
      case SUB:
      case LNEG:
      case BNEG:
      case BAND:
      case BOR:
      case BXOR:
      case BNAND:
      case BNOR:
      case BNXOR:
      case STRING:
      case 145:
      case 154:
        paramsList = expressionList();
        break;
      default:
        jj_la1[79] = jj_gen;
        ;
      }
      jj_consume_token(146);
      jj_consume_token(147);
    {if (true) return new TaskInstructionDescription(delayBefore, line, nsd, taskName, paramsList == null ? new Vector() : paramsList);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("taskEnableInstruction");
    }
  }

  final public InstructionDescription forkInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("forkInstruction");
    try {
  ForkDescription fork;
  InstructionDescription id;
  int line;
  String label = null;
      jj_consume_token(FORK);
           line = token.beginLine;
      switch (jj_nt.kind) {
      case 151:
        jj_consume_token(151);
        label = name();
        break;
      default:
        jj_la1[80] = jj_gen;
        ;
      }
       fork = new ForkDescription(delayBefore, line, nsd, label);
      label_23:
      while (true) {
        id = instruction(fork);
                                fork.addInside(id);
        switch (jj_nt.kind) {
        case BEGIN:
        case IF:
        case CASE:
        case CASEX:
        case CASEZ:
        case FOR:
        case WHILE:
        case REPEAT:
        case FORK:
        case DISPLAY:
        case DISPLAYB:
        case DISPLAYO:
        case DISPLAYH:
        case WRITE:
        case WRITEB:
        case WRITEO:
        case WRITEH:
        case MONITOR:
        case MONITORB:
        case MONITORO:
        case MONITORH:
        case STROBE:
        case STROBEB:
        case STROBEO:
        case STROBEH:
        case COUT:
        case FINISH:
        case POINT:
        case IDENTIFIER:
        case AT:
        case 147:
        case 153:
        case 154:
          ;
          break;
        default:
          jj_la1[81] = jj_gen;
          break label_23;
        }
      }
      jj_consume_token(JOIN);
    {if (true) return fork;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("forkInstruction");
    }
  }

  final public InstructionDescription caseInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("caseInstruction");
    try {
        xConsole.debug("case");
        ExpressionDescription ed, edt;
        InstructionDescription id;
        int type = 0;
        boolean wasDefault = false;
        Vector pairs = new Vector();
  int line;
      switch (jj_nt.kind) {
      case CASE:
        jj_consume_token(CASE);
        break;
      case CASEX:
        jj_consume_token(CASEX);
                    type = 1;
        break;
      case CASEZ:
        jj_consume_token(CASEZ);
                                          type = 2;
        break;
      default:
        jj_la1[82] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
                                                       line = token.beginLine;
      jj_consume_token(145);
      ed = expression();
      jj_consume_token(146);
      label_24:
      while (true) {
        switch (jj_nt.kind) {
        case CASEDEFAULT:
        case POINT:
        case IDENTIFIER:
        case unsigned_number:
        case bin_number:
        case oct_number:
        case dec_number:
        case hex_number:
        case real_number:
        case ADD:
        case SUB:
        case LNEG:
        case BNEG:
        case BAND:
        case BOR:
        case BXOR:
        case BNAND:
        case BNOR:
        case BNXOR:
        case STRING:
        case 145:
        case 154:
          ;
          break;
        default:
          jj_la1[83] = jj_gen;
          break label_24;
        }
        switch (jj_nt.kind) {
        case CASEDEFAULT:
          jj_consume_token(CASEDEFAULT);
        if (wasDefault) {if (true) throw new ParseException("Duplicate default label in case");}
        wasDefault = true;
        pairs.addElement(null);
          break;
        case POINT:
        case IDENTIFIER:
        case unsigned_number:
        case bin_number:
        case oct_number:
        case dec_number:
        case hex_number:
        case real_number:
        case ADD:
        case SUB:
        case LNEG:
        case BNEG:
        case BAND:
        case BOR:
        case BXOR:
        case BNAND:
        case BNOR:
        case BNXOR:
        case STRING:
        case 145:
        case 154:
          edt = expression();
                             pairs.addElement(edt);
          label_25:
          while (true) {
            switch (jj_nt.kind) {
            case 148:
              ;
              break;
            default:
              jj_la1[84] = jj_gen;
              break label_25;
            }
            jj_consume_token(148);
            edt = expression();
                                  pairs.addElement(edt);
          }
          break;
        default:
          jj_la1[85] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(151);
          id = null;
        if (jj_2_6(2147483647)) {
          id = instruction(nsd);
        } else {
          ;
        }
                                                                               pairs.addElement(id);
      }
      jj_consume_token(ENDCASE);
    if (pairs.size() < 1) {if (true) throw new ParseException("No labels for case");}
    {if (true) return new CaseInstructionDescription(delayBefore, line, nsd, type, ed, pairs);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("caseInstruction");
    }
  }

  final public InstructionDescription forInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("forInstruction");
    try {
        xConsole.debug("for");
        ExpressionDescription end = null;
        InstructionDescription id = null, initial = null, cycle = null;
  int line, dd;
      jj_consume_token(FOR);
              line = token.beginLine;
      jj_consume_token(145);
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
      case 153:
      case 154:
                                               dd = 0;
        switch (jj_nt.kind) {
        case 153:
          dd = delay();
          break;
        default:
          jj_la1[86] = jj_gen;
          ;
        }
        initial = procAssignExpression(dd, nsd);
        break;
      default:
        jj_la1[87] = jj_gen;
        ;
      }
      jj_consume_token(147);
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
      case unsigned_number:
      case bin_number:
      case oct_number:
      case dec_number:
      case hex_number:
      case real_number:
      case ADD:
      case SUB:
      case LNEG:
      case BNEG:
      case BAND:
      case BOR:
      case BXOR:
      case BNAND:
      case BNOR:
      case BNXOR:
      case STRING:
      case 145:
      case 154:
        end = expression();
        break;
      default:
        jj_la1[88] = jj_gen;
        ;
      }
      jj_consume_token(147);
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
      case 153:
      case 154:
                    dd = 0;
        switch (jj_nt.kind) {
        case 153:
          dd = delay();
          break;
        default:
          jj_la1[89] = jj_gen;
          ;
        }
        cycle = procAssignExpression(dd, nsd);
        break;
      default:
        jj_la1[90] = jj_gen;
        ;
      }
      jj_consume_token(146);
      id = instruction(nsd);
                {if (true) return new ForInstructionDescription(delayBefore, line, nsd, initial, end, cycle, id);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("forInstruction");
    }
  }

  final public InstructionDescription ifInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("ifInstruction");
    try {
        xConsole.debug("if");
        ExpressionDescription ed;
        InstructionDescription idTrue, idFalse = null;
  int line;
      jj_consume_token(IF);
              line = token.beginLine;
      jj_consume_token(145);
      ed = expression();
      jj_consume_token(146);
      idTrue = instruction(nsd);
      if (jj_2_7(2147483647)) {
        jj_consume_token(ELSE);
        idFalse = instruction(nsd);
      } else {
        ;
      }
                {if (true) return new IfInstructionDescription(delayBefore, line, nsd, ed, idTrue, idFalse);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ifInstruction");
    }
  }

  final public InstructionDescription repeatInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("repeatInstruction");
    try {
        xConsole.debug("repeat");
        ExpressionDescription ed;
        InstructionDescription id;
  int line;
      jj_consume_token(REPEAT);
                  line = token.beginLine;
      jj_consume_token(145);
      ed = expression();
      jj_consume_token(146);
      id = instruction(nsd);
                {if (true) return new RepeatInstructionDescription(delayBefore, line, nsd, ed, id);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("repeatInstruction");
    }
  }

  final public InstructionDescription whileInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("whileInstruction");
    try {
        xConsole.debug("while");
        ExpressionDescription ed;
        InstructionDescription id;
  int line;
      jj_consume_token(WHILE);
                 line = token.beginLine;
      jj_consume_token(145);
      ed = expression();
      jj_consume_token(146);
      id = instruction(nsd);
                {if (true) return new WhileInstructionDescription(delayBefore, line, nsd, ed, id);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("whileInstruction");
    }
  }

  final public InstructionDescription foreverInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("foreverInstruction");
    try {
        xConsole.debug("forever");
        InstructionDescription id;
  int line;
      jj_consume_token(FOREVER);
                  line = token.beginLine;
      id = instruction(nsd);
                {if (true) return new ForeverInstructionDescription(delayBefore, line, nsd, id);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("foreverInstruction");
    }
  }

  final public InstructionDescription atInstruction(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("atInstruction");
    try {
  InstructionDescription block = null;
  ValueChangeMonitorDescription vcmd;
  Vector monitors = new Vector();
  int line;
      jj_consume_token(AT);
         line = token.beginLine;
      if (jj_2_8(3)) {
        jj_consume_token(145);
        vcmd = frontExpression();
             monitors.addElement(vcmd);
        label_26:
        while (true) {
          switch (jj_nt.kind) {
          case OR:
            ;
            break;
          default:
            jj_la1[91] = jj_gen;
            break label_26;
          }
          jj_consume_token(OR);
          vcmd = frontExpression();
               monitors.addElement(vcmd);
        }
        jj_consume_token(146);
      } else {
        switch (jj_nt.kind) {
        case POSEDGE:
        case NEGEDGE:
        case POINT:
        case IDENTIFIER:
        case unsigned_number:
        case bin_number:
        case oct_number:
        case dec_number:
        case hex_number:
        case real_number:
        case ADD:
        case SUB:
        case LNEG:
        case BNEG:
        case BAND:
        case BOR:
        case BXOR:
        case BNAND:
        case BNOR:
        case BNXOR:
        case STRING:
        case 145:
        case 154:
          vcmd = frontExpression();
         monitors.addElement(vcmd);
          break;
        default:
          jj_la1[92] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      if (jj_2_9(2)) {
        jj_consume_token(147);
      } else {
        switch (jj_nt.kind) {
        case BEGIN:
        case IF:
        case CASE:
        case CASEX:
        case CASEZ:
        case FOR:
        case WHILE:
        case REPEAT:
        case FORK:
        case DISPLAY:
        case DISPLAYB:
        case DISPLAYO:
        case DISPLAYH:
        case WRITE:
        case WRITEB:
        case WRITEO:
        case WRITEH:
        case MONITOR:
        case MONITORB:
        case MONITORO:
        case MONITORH:
        case STROBE:
        case STROBEB:
        case STROBEO:
        case STROBEH:
        case COUT:
        case FINISH:
        case POINT:
        case IDENTIFIER:
        case AT:
        case 147:
        case 153:
        case 154:
          block = instruction(nsd);
          break;
        default:
          jj_la1[93] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    {if (true) return new AtInstructionDescription(delayBefore, line, nsd, monitors, block);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("atInstruction");
    }
  }

  final public ValueChangeMonitorDescription frontExpression() throws ParseException {
    trace_call("frontExpression");
    try {
  int mask = ValueChangeMonitor.EVT_CHANGE;
  ExpressionDescription ed;
      switch (jj_nt.kind) {
      case POSEDGE:
      case NEGEDGE:
        switch (jj_nt.kind) {
        case POSEDGE:
          jj_consume_token(POSEDGE);
                 mask = ValueChangeMonitor.EVT_POSEDGE;
          break;
        case NEGEDGE:
          jj_consume_token(NEGEDGE);
                   mask = ValueChangeMonitor.EVT_NEGEDGE;
          break;
        default:
          jj_la1[94] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[95] = jj_gen;
        ;
      }
      ed = expression();
    {if (true) return new ValueChangeMonitorDescription(curModule, ed, mask);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("frontExpression");
    }
  }

  final public InstructionDescription coutTask(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("coutTask");
    try {
  ExpressionDescription ex;
  int line;
      jj_consume_token(COUT);
            line = token.beginLine;
      jj_consume_token(145);
      ex = expression();
      jj_consume_token(146);
      jj_consume_token(147);
    {if (true) return new CoutTaskDescription(delayBefore, line, nsd, ex);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("coutTask");
    }
  }

  final public Vector displayParameterList() throws ParseException {
    trace_call("displayParameterList");
    try {
  Vector v = new Vector();
  String s = null;
  ExpressionDescription e = null;
      jj_consume_token(145);
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
      case unsigned_number:
      case bin_number:
      case oct_number:
      case dec_number:
      case hex_number:
      case real_number:
      case ADD:
      case SUB:
      case LNEG:
      case BNEG:
      case BAND:
      case BOR:
      case BXOR:
      case BNAND:
      case BNOR:
      case BNXOR:
      case STRING:
      case 145:
      case 154:
        if (jj_2_10(2147483647)) {
          jj_consume_token(STRING);
     s = token.image.substring(1, token.image.length()-1); v.addElement(stringTran(s));
        } else {
          switch (jj_nt.kind) {
          case POINT:
          case IDENTIFIER:
          case unsigned_number:
          case bin_number:
          case oct_number:
          case dec_number:
          case hex_number:
          case real_number:
          case ADD:
          case SUB:
          case LNEG:
          case BNEG:
          case BAND:
          case BOR:
          case BXOR:
          case BNAND:
          case BNOR:
          case BNXOR:
          case STRING:
          case 145:
          case 154:
            e = expression();
                        v.addElement(e);
            break;
          default:
            jj_la1[96] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[97] = jj_gen;
        ;
      }
    if (e == null && s == null) v.addElement(null);
      label_27:
      while (true) {
        switch (jj_nt.kind) {
        case 148:
          ;
          break;
        default:
          jj_la1[98] = jj_gen;
          break label_27;
        }
        jj_consume_token(148);
          s = null;  e = null;
        switch (jj_nt.kind) {
        case POINT:
        case IDENTIFIER:
        case unsigned_number:
        case bin_number:
        case oct_number:
        case dec_number:
        case hex_number:
        case real_number:
        case ADD:
        case SUB:
        case LNEG:
        case BNEG:
        case BAND:
        case BOR:
        case BXOR:
        case BNAND:
        case BNOR:
        case BNXOR:
        case STRING:
        case 145:
        case 154:
          if (jj_2_11(2147483647)) {
            jj_consume_token(STRING);
       s = token.image.substring(1, token.image.length()-1); v.addElement(stringTran(s));
          } else {
            switch (jj_nt.kind) {
            case POINT:
            case IDENTIFIER:
            case unsigned_number:
            case bin_number:
            case oct_number:
            case dec_number:
            case hex_number:
            case real_number:
            case ADD:
            case SUB:
            case LNEG:
            case BNEG:
            case BAND:
            case BOR:
            case BXOR:
            case BNAND:
            case BNOR:
            case BNXOR:
            case STRING:
            case 145:
            case 154:
              e = expression();
                          v.addElement(e);
              break;
            default:
              jj_la1[99] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          break;
        default:
          jj_la1[100] = jj_gen;
          ;
        }
      if (e == null && s == null) v.addElement(null);
      }
      jj_consume_token(146);
    {if (true) return v;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("displayParameterList");
    }
  }

  final public InstructionDescription displayTask(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("displayTask");
    try {
  int line, defaultBase = 10;
  Vector dpl;
      switch (jj_nt.kind) {
      case DISPLAY:
        jj_consume_token(DISPLAY);
        break;
      case DISPLAYB:
        jj_consume_token(DISPLAYB);
                          defaultBase = 2;
        break;
      case DISPLAYO:
        jj_consume_token(DISPLAYO);
                                                           defaultBase = 8;
        break;
      case DISPLAYH:
        jj_consume_token(DISPLAYH);
                                                                                            defaultBase = 16;
        break;
      default:
        jj_la1[101] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    line = token.beginLine;
      dpl = displayParameterList();
      jj_consume_token(147);
    {if (true) return new DisplayTaskDescription(delayBefore, line, nsd, defaultBase, dpl);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("displayTask");
    }
  }

  final public InstructionDescription strobeTask(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("strobeTask");
    try {
  int line, defaultBase = 10;
  Vector dpl;
      switch (jj_nt.kind) {
      case STROBE:
        jj_consume_token(STROBE);
        break;
      case STROBEB:
        jj_consume_token(STROBEB);
                      defaultBase = 2;
        break;
      case STROBEO:
        jj_consume_token(STROBEO);
                                                  defaultBase = 8;
        break;
      case STROBEH:
        jj_consume_token(STROBEH);
                                                                              defaultBase = 16;
        break;
      default:
        jj_la1[102] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    line = token.beginLine;
      dpl = displayParameterList();
      jj_consume_token(147);
    {if (true) return new DisplayTaskDescription(delayBefore, line, nsd, defaultBase, dpl, DisplayTaskDescription.d_strobe);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("strobeTask");
    }
  }

  final public InstructionDescription monitorTask(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("monitorTask");
    try {
  int line, defaultBase = 10;
  Vector dpl;
      switch (jj_nt.kind) {
      case MONITOR:
        jj_consume_token(MONITOR);
        break;
      case MONITORB:
        jj_consume_token(MONITORB);
                        defaultBase = 2;
        break;
      case MONITORO:
        jj_consume_token(MONITORO);
                                                     defaultBase = 8;
        break;
      case MONITORH:
        jj_consume_token(MONITORH);
                                                                                  defaultBase = 16;
        break;
      default:
        jj_la1[103] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    line = token.beginLine;
      dpl = displayParameterList();
      jj_consume_token(147);
    {if (true) return new DisplayTaskDescription(delayBefore, line, nsd, defaultBase, dpl, DisplayTaskDescription.d_monitor);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("monitorTask");
    }
  }

  final public InstructionDescription writeTask(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("writeTask");
    try {
  int line, defaultBase = 10;
  Vector dpl;
      switch (jj_nt.kind) {
      case WRITE:
        jj_consume_token(WRITE);
        break;
      case WRITEB:
        jj_consume_token(WRITEB);
                    defaultBase = 2;
        break;
      case WRITEO:
        jj_consume_token(WRITEO);
                                               defaultBase = 8;
        break;
      case WRITEH:
        jj_consume_token(WRITEH);
                                                                          defaultBase = 16;
        break;
      default:
        jj_la1[104] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    line = token.beginLine;
      dpl = displayParameterList();
      jj_consume_token(147);
    {if (true) return new DisplayTaskDescription(delayBefore, line, nsd, defaultBase, dpl, DisplayTaskDescription.d_write);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("writeTask");
    }
  }

  final public InstructionDescription begin(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("begin");
    try {
  InstructionDescription i = null;
  BlockDescription bd;
  String label = null;
  int line;
      jj_consume_token(BEGIN);
           line = token.beginLine;
      switch (jj_nt.kind) {
      case 151:
        jj_consume_token(151);
        label = name();
        break;
      default:
        jj_la1[105] = jj_gen;
        ;
      }
        bd = new BlockDescription(delayBefore, line, nsd, label);
      switch (jj_nt.kind) {
      case REG:
      case INTEGER:
      case REAL:
      case TIME:
      case REALTIME:
      case EVENT:
      case PARAMETER:
        blockDeclare(bd);
        break;
      default:
        jj_la1[106] = jj_gen;
        ;
      }
      label_28:
      while (true) {
        i = instruction(label != null ? bd : nsd);
                                                     bd.addInside(i);
        switch (jj_nt.kind) {
        case BEGIN:
        case IF:
        case CASE:
        case CASEX:
        case CASEZ:
        case FOR:
        case WHILE:
        case REPEAT:
        case FORK:
        case DISPLAY:
        case DISPLAYB:
        case DISPLAYO:
        case DISPLAYH:
        case WRITE:
        case WRITEB:
        case WRITEO:
        case WRITEH:
        case MONITOR:
        case MONITORB:
        case MONITORO:
        case MONITORH:
        case STROBE:
        case STROBEB:
        case STROBEO:
        case STROBEH:
        case COUT:
        case FINISH:
        case POINT:
        case IDENTIFIER:
        case AT:
        case 147:
        case 153:
        case 154:
          ;
          break;
        default:
          jj_la1[107] = jj_gen;
          break label_28;
        }
      }
      jj_consume_token(END);
    {if (true) return bd;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("begin");
    }
  }

  final public ProcAssignInstrucDescription procAssign(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("procAssign");
    try {
  ProcAssignInstrucDescription paid;
      paid = procAssignExpression(delayBefore, nsd);
      jj_consume_token(147);
    {if (true) return paid;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("procAssign");
    }
  }

  final public ProcAssignInstrucDescription procAssignExpression(int delayBefore, NameSpaceDescription nsd) throws ParseException {
    trace_call("procAssignExpression");
    try {
  ProcAssignInstrucDescription paid;
  ExpressionDescription exd;
  ExpressionDescription sed;
  int delayMiddle = 0;
  boolean blocking;
  int line;
      sed = selectionExpression();
                              line = token.beginLine;
      switch (jj_nt.kind) {
      case 149:
        jj_consume_token(149);
        blocking = true;
        break;
      case LE:
        jj_consume_token(LE);
                                  blocking = false;
        break;
      default:
        jj_la1[108] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch (jj_nt.kind) {
      case 153:
        delayMiddle = delay();
        break;
      default:
        jj_la1[109] = jj_gen;
        ;
      }
      exd = expression();
    {if (true) return new ProcAssignInstrucDescription(delayBefore, line, nsd, sed, exd, delayMiddle, blocking);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("procAssignExpression");
    }
  }

/////////////////////////////////////////////////////////////////////
//
//                EXPRESSIONS
//
/////////////////////////////////////////////////////////////////////
  final public ExpressionDescription expression() throws ParseException {
    trace_call("expression");
    try {
  ExpressionDescription ed;
      ed = conditionalExpression();
    {if (true) return ed;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("expression");
    }
  }

  final public ExpressionDescription atomicExpression() throws ParseException {
    trace_call("atomicExpression");
    try {
  ExpressionDescription ed;
      if (jj_2_12(2)) {
        jj_consume_token(145);
        ed = expression();
        jj_consume_token(146);
      } else {
        switch (jj_nt.kind) {
        case unsigned_number:
        case bin_number:
        case oct_number:
        case dec_number:
        case hex_number:
        case real_number:
        case ADD:
        case SUB:
        case STRING:
          ed = constant();
          break;
        default:
          jj_la1[110] = jj_gen;
          if (jj_2_13(2147483647)) {
            ed = functionCall();
          } else if (jj_2_14(3)) {
            ed = selectionExpression();
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    {if (true) return ed;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("atomicExpression");
    }
  }

  final public ExpressionDescription functionCall() throws ParseException {
    trace_call("functionCall");
    try {
  String fqn;
  Vector paramsList = null;
      fqn = fqName();
      jj_consume_token(145);
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
      case unsigned_number:
      case bin_number:
      case oct_number:
      case dec_number:
      case hex_number:
      case real_number:
      case ADD:
      case SUB:
      case LNEG:
      case BNEG:
      case BAND:
      case BOR:
      case BXOR:
      case BNAND:
      case BNOR:
      case BNXOR:
      case STRING:
      case 145:
      case 154:
        paramsList = expressionList();
        break;
      default:
        jj_la1[111] = jj_gen;
        ;
      }
      jj_consume_token(146);
    {if (true) return new FunctionCallExpressionDescription(fqn, paramsList);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("functionCall");
    }
  }

  final public ExpressionDescription selectionExpression() throws ParseException {
    trace_call("selectionExpression");
    try {
  SelectionExpressionDescription sed = new SelectionExpressionDescription();
  ChunkDescription c;
  ExpressionDescription ed;
      switch (jj_nt.kind) {
      case POINT:
      case IDENTIFIER:
        ed = symbolSelection();
                             {if (true) return ed;}
        break;
      case 154:
        jj_consume_token(154);
        c = chunk();
                      sed.addChunk(c);
        label_29:
        while (true) {
          switch (jj_nt.kind) {
          case 148:
            ;
            break;
          default:
            jj_la1[112] = jj_gen;
            break label_29;
          }
          jj_consume_token(148);
          c = chunk();
                        sed.addChunk(c);
        }
        jj_consume_token(155);
        break;
      default:
        jj_la1[113] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    {if (true) return sed;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("selectionExpression");
    }
  }

////////////////////////////////
//
//        CONSTANTS
//
/////////////////////////////////
  final public ExpressionDescription constant() throws ParseException {
    trace_call("constant");
    try {
  ExpressionDescription exd;
      if (jj_2_15(3)) {
        exd = binaryConstant();
      } else if (jj_2_16(3)) {
        exd = octalConstant();
      } else if (jj_2_17(3)) {
        exd = hexaConstant();
      } else if (jj_2_18(3)) {
        exd = decimalConstant();
      } else if (jj_2_19(3)) {
        exd = realConstant();
      } else {
        switch (jj_nt.kind) {
        case STRING:
          exd = stringConstant();
          break;
        default:
          jj_la1[114] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    {if (true) return exd;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("constant");
    }
  }

  final public ExpressionDescription realConstant() throws ParseException {
    trace_call("realConstant");
    try {
      jj_consume_token(real_number);
    {if (true) return ConstantDescription.createNewRealConstantDescription(
      unUnderscore(token.image));}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("realConstant");
    }
  }

  final public ExpressionDescription stringConstant() throws ParseException {
    trace_call("stringConstant");
    try {
      jj_consume_token(STRING);
    String image = token.image.substring(1, token.image.length()-1);
    {if (true) return ConstantDescription.createNewStringConstantDescription(stringTran(image));}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("stringConstant");
    }
  }

//the size specificator for constants
  final public int sizeSpec() throws ParseException {
    trace_call("sizeSpec");
    try {
  int size = -1;
      jj_consume_token(unsigned_number);
    try{
      size = Integer.parseInt(unUnderscore(token.image));
    }catch(NumberFormatException ex){
      {if (true) throw new Error("numberformatexception allowed by grammar ??");}
    }
    {if (true) return size;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("sizeSpec");
    }
  }

  final public ExpressionDescription decimalConstant() throws ParseException {
    trace_call("decimalConstant");
    try {
  boolean signed = true, sign=false;
  int size = -1;
      switch (jj_nt.kind) {
      case ADD:
      case SUB:
        switch (jj_nt.kind) {
        case SUB:
          jj_consume_token(SUB);
        sign = true;
          break;
        case ADD:
          jj_consume_token(ADD);
          break;
        default:
          jj_la1[115] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[116] = jj_gen;
        ;
      }
      if (jj_2_20(2)) {
        switch (jj_nt.kind) {
        case unsigned_number:
          size = sizeSpec();
          break;
        default:
          jj_la1[117] = jj_gen;
          ;
        }
        jj_consume_token(dec_number);
        token.image = token.image.toLowerCase().substring(1); //cut: '
        token.image = token.image.substring(
          token.image.lastIndexOf('d') + 1);
        signed = false;
      } else {
        switch (jj_nt.kind) {
        case unsigned_number:
          jj_consume_token(unsigned_number);
          break;
        default:
          jj_la1[118] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
   {if (true) return ConstantDescription.createNewSignedConstantDescription(size, signed, sign,
                                      10, unUnderscore(token.image));}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("decimalConstant");
    }
  }

  final public ExpressionDescription binaryConstant() throws ParseException {
    trace_call("binaryConstant");
    try {
  int size = -1;
  boolean sign = false;
      switch (jj_nt.kind) {
      case ADD:
      case SUB:
        switch (jj_nt.kind) {
        case SUB:
          jj_consume_token(SUB);
        sign = true;
          break;
        case ADD:
          jj_consume_token(ADD);
          break;
        default:
          jj_la1[119] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[120] = jj_gen;
        ;
      }
      switch (jj_nt.kind) {
      case unsigned_number:
        size = sizeSpec();
        break;
      default:
        jj_la1[121] = jj_gen;
        ;
      }
      jj_consume_token(bin_number);
   {if (true) return ConstantDescription.createNewSignedConstantDescription(size, false, sign, 2,
                  unUnderscore(token.image.substring(2)));}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("binaryConstant");
    }
  }

  final public ExpressionDescription octalConstant() throws ParseException {
    trace_call("octalConstant");
    try {
  int size = -1;
  boolean sign = false;
      switch (jj_nt.kind) {
      case ADD:
      case SUB:
        switch (jj_nt.kind) {
        case SUB:
          jj_consume_token(SUB);
        sign = true;
          break;
        case ADD:
          jj_consume_token(ADD);
          break;
        default:
          jj_la1[122] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[123] = jj_gen;
        ;
      }
      switch (jj_nt.kind) {
      case unsigned_number:
        size = sizeSpec();
        break;
      default:
        jj_la1[124] = jj_gen;
        ;
      }
      jj_consume_token(oct_number);
   {if (true) return ConstantDescription.createNewSignedConstantDescription(size, false, sign, 8,
                  unUnderscore(token.image.substring(2)));}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("octalConstant");
    }
  }

  final public ExpressionDescription hexaConstant() throws ParseException {
    trace_call("hexaConstant");
    try {
  int size = -1;
  boolean sign = false;
      switch (jj_nt.kind) {
      case ADD:
      case SUB:
        switch (jj_nt.kind) {
        case SUB:
          jj_consume_token(SUB);
        sign = true;
          break;
        case ADD:
          jj_consume_token(ADD);
          break;
        default:
          jj_la1[125] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[126] = jj_gen;
        ;
      }
      switch (jj_nt.kind) {
      case unsigned_number:
        size = sizeSpec();
        break;
      default:
        jj_la1[127] = jj_gen;
        ;
      }
      jj_consume_token(hex_number);
   {if (true) return ConstantDescription.createNewSignedConstantDescription(size, false, sign, 16,
                  unUnderscore(token.image.substring(2)));}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("hexaConstant");
    }
  }

////////////////////////////////////////////////////////
//
// COMPOSITE EXPRESSIONS
//
/////////////////////////////////////////////////////////
  final public ExpressionDescription conditionalExpression() throws ParseException {
    trace_call("conditionalExpression");
    try {
  ExpressionDescription ed0, ed1, ed2;
      ed0 = logicalOrExpression();
      if (jj_2_21(2)) {
        jj_consume_token(156);
        ed1 = conditionalExpression();
        jj_consume_token(151);
        ed2 = conditionalExpression();
      ed0 = new ConditionalExpressionDescription(ed0, ed1, ed2);
      } else {
        ;
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("conditionalExpression");
    }
  }

  final public ExpressionDescription logicalOrExpression() throws ParseException {
    trace_call("logicalOrExpression");
    try {
  ExpressionDescription ed0, ed1;
      ed0 = logicalAndExpression();
      label_30:
      while (true) {
        if (jj_2_22(2)) {
          ;
        } else {
          break label_30;
        }
        jj_consume_token(LOR);
        ed1 = logicalAndExpression();
      ed0 = new BinaryExpressionDescription(ed0, "||", ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("logicalOrExpression");
    }
  }

  final public ExpressionDescription logicalAndExpression() throws ParseException {
    trace_call("logicalAndExpression");
    try {
  ExpressionDescription ed0, ed1;
      ed0 = bitwiseOrExpression();
      label_31:
      while (true) {
        if (jj_2_23(2)) {
          ;
        } else {
          break label_31;
        }
        jj_consume_token(LAND);
        ed1 = bitwiseOrExpression();
      ed0 = new BinaryExpressionDescription(ed0, "&&", ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("logicalAndExpression");
    }
  }

  final public ExpressionDescription bitwiseOrExpression() throws ParseException {
    trace_call("bitwiseOrExpression");
    try {
  ExpressionDescription ed0, ed1;
  String operator;
      ed0 = bitwiseAndXorExpression();
      label_32:
      while (true) {
        if (jj_2_24(2)) {
          ;
        } else {
          break label_32;
        }
        switch (jj_nt.kind) {
        case BOR:
          jj_consume_token(BOR);
          break;
        case BNOR:
          jj_consume_token(BNOR);
          break;
        default:
          jj_la1[128] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                    operator = token.image;
        ed1 = bitwiseAndXorExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("bitwiseOrExpression");
    }
  }

  final public ExpressionDescription bitwiseAndXorExpression() throws ParseException {
    trace_call("bitwiseAndXorExpression");
    try {
  ExpressionDescription ed0, ed1;
  String operator;
      ed0 = equalityExpression();
      label_33:
      while (true) {
        if (jj_2_25(2)) {
          ;
        } else {
          break label_33;
        }
        switch (jj_nt.kind) {
        case BXOR:
          jj_consume_token(BXOR);
          break;
        case BAND:
          jj_consume_token(BAND);
          break;
        case BNXOR:
          jj_consume_token(BNXOR);
          break;
        case BNAND:
          jj_consume_token(BNAND);
          break;
        default:
          jj_la1[129] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                                         operator = token.image;
        ed1 = equalityExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("bitwiseAndXorExpression");
    }
  }

  final public ExpressionDescription equalityExpression() throws ParseException {
    trace_call("equalityExpression");
    try {
  ExpressionDescription ed0, ed1 = null;
  String operator;
      ed0 = lessOrGreaterExpression();
      label_34:
      while (true) {
        if (jj_2_26(2)) {
          ;
        } else {
          break label_34;
        }
        switch (jj_nt.kind) {
        case EQ:
          jj_consume_token(EQ);
          break;
        case NEQ:
          jj_consume_token(NEQ);
          break;
        case CEQ:
          jj_consume_token(CEQ);
          break;
        case CNEQ:
          jj_consume_token(CNEQ);
          break;
        default:
          jj_la1[130] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                                   operator = token.image;
        ed1 = lessOrGreaterExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("equalityExpression");
    }
  }

  final public ExpressionDescription lessOrGreaterExpression() throws ParseException {
    trace_call("lessOrGreaterExpression");
    try {
  ExpressionDescription ed0, ed1;
  String operator;
      ed0 = shiftExpression();
      label_35:
      while (true) {
        if (jj_2_27(2)) {
          ;
        } else {
          break label_35;
        }
        switch (jj_nt.kind) {
        case LT:
          jj_consume_token(LT);
          break;
        case GT:
          jj_consume_token(GT);
          break;
        case LE:
          jj_consume_token(LE);
          break;
        case GE:
          jj_consume_token(GE);
          break;
        default:
          jj_la1[131] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                               operator = token.image;
        ed1 = shiftExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lessOrGreaterExpression");
    }
  }

  final public ExpressionDescription shiftExpression() throws ParseException {
    trace_call("shiftExpression");
    try {
  ExpressionDescription ed0, ed1;
  String operator;
      ed0 = addExpression();
      label_36:
      while (true) {
        if (jj_2_28(2)) {
          ;
        } else {
          break label_36;
        }
        switch (jj_nt.kind) {
        case SHL:
          jj_consume_token(SHL);
          break;
        case SHR:
          jj_consume_token(SHR);
          break;
        default:
          jj_la1[132] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                   operator = token.image;
        ed1 = addExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("shiftExpression");
    }
  }

  final public ExpressionDescription addExpression() throws ParseException {
    trace_call("addExpression");
    try {
  ExpressionDescription ed0, ed1;
  String operator;
      ed0 = multiplyExpression();
      label_37:
      while (true) {
        if (jj_2_29(2)) {
          ;
        } else {
          break label_37;
        }
        switch (jj_nt.kind) {
        case ADD:
          jj_consume_token(ADD);
          break;
        case SUB:
          jj_consume_token(SUB);
          break;
        default:
          jj_la1[133] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                   operator = token.image;
        ed1 = multiplyExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("addExpression");
    }
  }

  final public ExpressionDescription multiplyExpression() throws ParseException {
    trace_call("multiplyExpression");
    try {
  ExpressionDescription ed0, ed1;
  String operator;
      ed0 = unaryExpression();
      label_38:
      while (true) {
        if (jj_2_30(2)) {
          ;
        } else {
          break label_38;
        }
        switch (jj_nt.kind) {
        case MUL:
          jj_consume_token(MUL);
          break;
        case DIV:
          jj_consume_token(DIV);
          break;
        case MOD:
          jj_consume_token(MOD);
          break;
        default:
          jj_la1[134] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
                                           operator = token.image;
        ed1 = unaryExpression();
      ed0 = new BinaryExpressionDescription(ed0, operator, ed1);
      }
    {if (true) return ed0;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("multiplyExpression");
    }
  }

  final public ExpressionDescription unaryExpression() throws ParseException {
    trace_call("unaryExpression");
    try {
  ExpressionDescription ed;
  String operator = null;
      if (jj_2_31(2)) {
        ed = atomicExpression();
      } else {
        switch (jj_nt.kind) {
        case ADD:
        case SUB:
        case LNEG:
        case BNEG:
        case BAND:
        case BOR:
        case BXOR:
        case BNAND:
        case BNOR:
        case BNXOR:
          switch (jj_nt.kind) {
          case SUB:
            jj_consume_token(SUB);
            break;
          case ADD:
            jj_consume_token(ADD);
            break;
          case BNEG:
            jj_consume_token(BNEG);
            break;
          case BOR:
            jj_consume_token(BOR);
            break;
          case BNOR:
            jj_consume_token(BNOR);
            break;
          case BAND:
            jj_consume_token(BAND);
            break;
          case BNAND:
            jj_consume_token(BNAND);
            break;
          case BXOR:
            jj_consume_token(BXOR);
            break;
          case BNXOR:
            jj_consume_token(BNXOR);
            break;
          case LNEG:
            jj_consume_token(LNEG);
            break;
          default:
            jj_la1[135] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          operator = token.image;
          ed = atomicExpression();
          break;
        default:
          jj_la1[136] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    {if (true) return operator == null ? ed : new UnaryExpressionDescription(operator, ed);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("unaryExpression");
    }
  }

//////////////////////////////////////////////////////////////////////
//
//                   COMMON TOKENS
//
///////////////////////////////////////////////////////////////////////
  final public ExpressionDescription symbolSelection() throws ParseException {
    trace_call("symbolSelection");
    try {
  String fqn;
  ExpressionDescription start = null, end = null;
  boolean hasLimits = false;
  ExpressionDescription exp;
      fqn = fqName();
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        start = expression();
                                 hasLimits = true; end = start;
        switch (jj_nt.kind) {
        case 151:
          jj_consume_token(151);
          end = expression();
          break;
        default:
          jj_la1[137] = jj_gen;
          ;
        }
        jj_consume_token(152);
        break;
      default:
        jj_la1[138] = jj_gen;
        ;
      }
    {if (true) return new GenericSelectorDescription(fqn, start, end, hasLimits);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("symbolSelection");
    }
  }

  final public ChunkDescription chunk() throws ParseException {
    trace_call("chunk");
    try {
  int id ;
  boolean hasLimits = false;
  ExpressionDescription start = null, end = null;
  String fqn;
      fqn = fqName();
      switch (jj_nt.kind) {
      case 150:
        jj_consume_token(150);
        start = expression();
        hasLimits = true;
        end = start;
        switch (jj_nt.kind) {
        case 151:
          jj_consume_token(151);
          end = expression();
          break;
        default:
          jj_la1[139] = jj_gen;
          ;
        }
        jj_consume_token(152);
        break;
      default:
        jj_la1[140] = jj_gen;
        ;
      }
    {if (true) return hasLimits ? new ChunkDescription(fqn, start, end) : new ChunkDescription(fqn);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("chunk");
    }
  }

  final public String name() throws ParseException {
    trace_call("name");
    try {
      jj_consume_token(IDENTIFIER);
    {if (true) return token.image;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("name");
    }
  }

  final public String fqName() throws ParseException {
    trace_call("fqName");
    try {
  StringBuffer fqn = new StringBuffer();
      switch (jj_nt.kind) {
      case POINT:
        jj_consume_token(POINT);
             fqn.append(token.image);
        break;
      default:
        jj_la1[141] = jj_gen;
        ;
      }
      jj_consume_token(IDENTIFIER);
                                                      fqn.append(token.image);
      label_39:
      while (true) {
        if (jj_2_32(2)) {
          ;
        } else {
          break label_39;
        }
        jj_consume_token(POINT);
                             fqn.append(token.image);
        jj_consume_token(IDENTIFIER);
                                                                    fqn.append(token.image);
      }
    {if (true) return fqn.toString();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("fqName");
    }
  }

/**
 * @deprecated: delay must be expressions !
 */
//TODO /
  final public int delay() throws ParseException {
    trace_call("delay");
    try {
      jj_consume_token(153);
      jj_consume_token(unsigned_number);
    try {
      {if (true) return Integer.parseInt(unUnderscore(token.image));}
    }
    catch (NumberFormatException err) {
      {if (true) throw new ParseException("Not a number");}
    }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("delay");
    }
  }

  final public Delay3Description delay3(NameSpaceDescription nsd) throws ParseException {
    trace_call("delay3");
    try {
  Delay3Description delays = new Delay3Description();
  Vector delayValues;
      jj_consume_token(153);
      if (jj_2_33(2147483647)) {
        delayValues = delayValue(nsd);
                                    delays.delaySpecs = 1; delays.copyDelays(delayValues, 1);
      } else {
        switch (jj_nt.kind) {
        case 145:
          jj_consume_token(145);
          delayValues = delayValue(nsd);
                                           delays.delaySpecs = 1; delays.copyDelays(delayValues, 1);
          switch (jj_nt.kind) {
          case 148:
            jj_consume_token(148);
            delayValues = delayValue(nsd);
                                           delays.delaySpecs = 2; delays.copyDelays(delayValues, 2);
            switch (jj_nt.kind) {
            case 148:
              jj_consume_token(148);
              delayValues = delayValue(nsd);
                                            delays.delaySpecs = 3; delays.copyDelays(delayValues, 3);
              break;
            default:
              jj_la1[142] = jj_gen;
              ;
            }
            break;
          default:
            jj_la1[143] = jj_gen;
            ;
          }
          jj_consume_token(146);
          break;
        default:
          jj_la1[144] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    {if (true) return delays;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("delay3");
    }
  }

  final public Vector delayValue(NameSpaceDescription nsd) throws ParseException {
    trace_call("delayValue");
    try {
  Vector delays = new Vector(3);
  ExpressionDescription exd;
      exd = expression();
                        delays.addElement(exd);
      switch (jj_nt.kind) {
      case 151:
        jj_consume_token(151);
        exd = expression();
                              delays.addElement(exd);
        jj_consume_token(151);
        exd = expression();
                                                                               delays.addElement(exd);
        break;
      default:
        jj_la1[145] = jj_gen;
        ;
      }
    {if (true) return delays;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("delayValue");
    }
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_26();
    jj_save(25, xla);
    return retval;
  }

  final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_27();
    jj_save(26, xla);
    return retval;
  }

  final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_28();
    jj_save(27, xla);
    return retval;
  }

  final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_29();
    jj_save(28, xla);
    return retval;
  }

  final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_30();
    jj_save(29, xla);
    return retval;
  }

  final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_31();
    jj_save(30, xla);
    return retval;
  }

  final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_32();
    jj_save(31, xla);
    return retval;
  }

  final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_33();
    jj_save(32, xla);
    return retval;
  }

  final private boolean jj_3R_70() {
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_26()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_64() {
    if (jj_scan_token(BNOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_147() {
    if (jj_scan_token(NEGEDGE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_111() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_146()) {
    jj_scanpos = xsp;
    if (jj_3R_147()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_146() {
    if (jj_scan_token(POSEDGE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_63() {
    if (jj_scan_token(BOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_25() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_66()) {
    jj_scanpos = xsp;
    if (jj_3R_67()) {
    jj_scanpos = xsp;
    if (jj_3R_68()) {
    jj_scanpos = xsp;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_65() {
    if (jj_3R_70()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_25()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_49() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_111()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_187() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_24() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_62() {
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_24()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_9() {
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_186() {
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_23() {
    if (jj_scan_token(LAND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_61() {
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_23()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_8() {
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_49()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_50()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_22() {
    if (jj_scan_token(LOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_137() {
    if (jj_scan_token(AT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3R_187()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_124() {
    if (jj_3R_61()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_22()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3_21() {
    if (jj_scan_token(156)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_156() {
    if (jj_scan_token(ADD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_60() {
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_21()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_230() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(POINT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_142() {
    if (jj_scan_token(WHILE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_154() {
    if (jj_scan_token(ADD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_120() {
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_155() {
    if (jj_scan_token(SUB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_119() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_56() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_119()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_120()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(hex_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_193() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_230()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_138() {
    if (jj_scan_token(REPEAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_152() {
    if (jj_scan_token(ADD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_118() {
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_153() {
    if (jj_scan_token(SUB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_117() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_153()) {
    jj_scanpos = xsp;
    if (jj_3R_154()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_231() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_55() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_117()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_118()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(oct_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_188() {
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_139() {
    if (jj_scan_token(IF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_188()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_116() {
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_151() {
    if (jj_scan_token(SUB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_195() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_231()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_115() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_151()) {
    jj_scanpos = xsp;
    if (jj_3R_152()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_54() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_115()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_116()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(bin_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_194() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_158() {
    if (jj_scan_token(ADD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_122() {
    if (jj_scan_token(unsigned_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_229() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_141() {
    if (jj_scan_token(FOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_193()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_194()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_195()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_191() {
    if (jj_scan_token(CASEZ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_59() {
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_20() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_59()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(dec_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_157() {
    if (jj_scan_token(SUB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_121() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_157()) {
    jj_scanpos = xsp;
    if (jj_3R_158()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_196() {
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_57() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_121()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_20()) {
    jj_scanpos = xsp;
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_251() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_228() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_251()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_190() {
    if (jj_scan_token(CASEX)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_227() {
    if (jj_scan_token(CASEDEFAULT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_192() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_227()) {
    jj_scanpos = xsp;
    if (jj_3R_228()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_229()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_123() {
    if (jj_scan_token(unsigned_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_189() {
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_140() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_192()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(ENDCASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_94() {
    if (jj_scan_token(149)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_233() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_197() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_94()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_143() {
    if (jj_scan_token(FORK)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_196()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_197()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_197()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(JOIN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_202() {
    if (jj_3R_233()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_58() {
    if (jj_scan_token(real_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_198() {
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_144() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_198()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_19() {
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_18() {
    if (jj_3R_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_17() {
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_16() {
    if (jj_3R_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_15() {
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_3R_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_169() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_15()) {
    jj_scanpos = xsp;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3_17()) {
    jj_scanpos = xsp;
    if (jj_3_18()) {
    jj_scanpos = xsp;
    if (jj_3_19()) {
    jj_scanpos = xsp;
    if (jj_3R_202()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    if (jj_3R_92()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_41()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_42()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_43()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_44()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_45()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_252() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_232() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_252()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_213() {
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_150() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_149()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_185() {
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_173() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_213()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_184() {
    if (jj_3R_225()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_183() {
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_182() {
    if (jj_3R_223()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_181() {
    if (jj_3R_222()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_114() {
    if (jj_scan_token(154)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_149()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_150()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(155)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_136() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_181()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) {
    jj_scanpos = xsp;
    if (jj_3R_183()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) {
    jj_scanpos = xsp;
    if (jj_3R_185()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_113() {
    if (jj_3R_148()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_33() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_199() {
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_131() {
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_173()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_271() {
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_265() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_130() {
    if (jj_3R_173()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_107() {
    if (jj_3R_143()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_258() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_265()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_106() {
    if (jj_3R_142()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_145() {
    if (jj_scan_token(FINISH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_199()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_105() {
    if (jj_3R_141()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_93() {
    if (jj_scan_token(153)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_130()) {
    jj_scanpos = xsp;
    if (jj_3R_131()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_104() {
    if (jj_3R_140()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_103() {
    if (jj_3R_139()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_170() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_271()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_102() {
    if (jj_3R_138()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_13() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_257() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_110() {
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_109() {
    if (jj_3R_145()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_108() {
    if (jj_3R_144()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_256() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_14() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_101() {
    if (jj_3R_137()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_127() {
    if (jj_3R_170()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_215() {
    if (jj_scan_token(REG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_256()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_257()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_258()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_100() {
    if (jj_3R_136()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_126() {
    if (jj_3R_169()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_135() {
    if (jj_scan_token(153)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(unsigned_number)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_3R_47()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_12() {
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_91() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_12()) {
    jj_scanpos = xsp;
    if (jj_3R_126()) {
    jj_scanpos = xsp;
    if (jj_3R_127()) {
    jj_scanpos = xsp;
    if (jj_3_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_134() {
    if (jj_scan_token(LE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_99() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_99()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3_5()) {
    jj_scanpos = xsp;
    if (jj_3R_100()) {
    jj_scanpos = xsp;
    if (jj_3R_101()) {
    jj_scanpos = xsp;
    if (jj_3R_102()) {
    jj_scanpos = xsp;
    if (jj_3R_103()) {
    jj_scanpos = xsp;
    if (jj_3R_104()) {
    jj_scanpos = xsp;
    if (jj_3R_105()) {
    jj_scanpos = xsp;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) {
    jj_scanpos = xsp;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_32() {
    if (jj_scan_token(POINT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_112() {
    if (jj_scan_token(POINT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_266() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_242() {
    if (jj_scan_token(WRITEH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_112()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_32()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_260() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_266()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_250() {
    if (jj_scan_token(MONITORH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_95() {
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_259() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_221() {
    if (jj_3R_135()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_133() {
    if (jj_scan_token(149)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_268() {
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_98() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_133()) {
    jj_scanpos = xsp;
    if (jj_3R_134()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_221()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_216() {
    if (jj_scan_token(INTEGER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_259()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_260()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_246() {
    if (jj_scan_token(STROBEH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_201() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_268()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_168() {
    if (jj_scan_token(LNEG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_261() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_241() {
    if (jj_scan_token(WRITEO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_237() {
    if (jj_scan_token(DISPLAYH)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_149() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_201()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_217() {
    if (jj_scan_token(REAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_261()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_163() {
    if (jj_scan_token(BNOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_167() {
    if (jj_scan_token(BNXOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_267() {
    if (jj_scan_token(151)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_249() {
    if (jj_scan_token(MONITORO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_97() {
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_162() {
    if (jj_scan_token(BOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_129() {
    if (jj_3R_172()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_255() {
    if (jj_scan_token(149)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_96() {
    if (jj_3R_132()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_200() {
    if (jj_scan_token(150)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_267()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(152)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_166() {
    if (jj_scan_token(BXOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_214() {
    if (jj_scan_token(PARAMETER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_255()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_scan_token(BEGIN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_95()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_96()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_97()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_97()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(END)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_161() {
    if (jj_scan_token(BNEG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_148() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_200()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_245() {
    if (jj_scan_token(STROBEO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_165() {
    if (jj_scan_token(BNAND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_240() {
    if (jj_scan_token(WRITEB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_220() {
    if (jj_scan_token(EVENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_160() {
    if (jj_scan_token(ADD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_89() {
    if (jj_scan_token(MOD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_236() {
    if (jj_scan_token(DISPLAYO)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_207() {
    if (jj_scan_token(HIGHZ0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_206() {
    if (jj_scan_token(WEAK0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_239() {
    if (jj_scan_token(WRITE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_219() {
    if (jj_scan_token(REALTIME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_205() {
    if (jj_scan_token(PULL0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_164() {
    if (jj_scan_token(BAND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_224() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_239()) {
    jj_scanpos = xsp;
    if (jj_3R_240()) {
    jj_scanpos = xsp;
    if (jj_3R_241()) {
    jj_scanpos = xsp;
    if (jj_3R_242()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_238()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_204() {
    if (jj_scan_token(STRONG0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_159() {
    if (jj_scan_token(SUB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_88() {
    if (jj_scan_token(DIV)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_203() {
    if (jj_scan_token(SUPPLY0)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_171() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_203()) {
    jj_scanpos = xsp;
    if (jj_3R_204()) {
    jj_scanpos = xsp;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_248() {
    if (jj_scan_token(MONITORB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_125() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_159()) {
    jj_scanpos = xsp;
    if (jj_3R_160()) {
    jj_scanpos = xsp;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) {
    jj_scanpos = xsp;
    if (jj_3R_163()) {
    jj_scanpos = xsp;
    if (jj_3R_164()) {
    jj_scanpos = xsp;
    if (jj_3R_165()) {
    jj_scanpos = xsp;
    if (jj_3R_166()) {
    jj_scanpos = xsp;
    if (jj_3R_167()) {
    jj_scanpos = xsp;
    if (jj_3R_168()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_91()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_31() {
    if (jj_3R_91()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_218() {
    if (jj_scan_token(TIME)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_212() {
    if (jj_scan_token(HIGHZ1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_211() {
    if (jj_scan_token(WEAK1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_87() {
    if (jj_scan_token(MUL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_210() {
    if (jj_scan_token(PULL1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_209() {
    if (jj_scan_token(STRONG1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_208() {
    if (jj_scan_token(SUPPLY1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_172() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_208()) {
    jj_scanpos = xsp;
    if (jj_3R_209()) {
    jj_scanpos = xsp;
    if (jj_3R_210()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) {
    jj_scanpos = xsp;
    if (jj_3R_212()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_90() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_31()) {
    jj_scanpos = xsp;
    if (jj_3R_125()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_247() {
    if (jj_scan_token(MONITOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_226() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_247()) {
    jj_scanpos = xsp;
    if (jj_3R_248()) {
    jj_scanpos = xsp;
    if (jj_3R_249()) {
    jj_scanpos = xsp;
    if (jj_3R_250()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_238()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_85() {
    if (jj_scan_token(SUB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_244() {
    if (jj_scan_token(STROBEB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_128() {
    if (jj_3R_171()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_92() {
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_128()) {
    jj_scanpos = xsp;
    if (jj_3R_129()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_30() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_87()) {
    jj_scanpos = xsp;
    if (jj_3R_88()) {
    jj_scanpos = xsp;
    if (jj_3R_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_90()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_84() {
    if (jj_scan_token(ADD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_86() {
    if (jj_3R_90()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_30()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_243() {
    if (jj_scan_token(STROBE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_225() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_243()) {
    jj_scanpos = xsp;
    if (jj_3R_244()) {
    jj_scanpos = xsp;
    if (jj_3R_245()) {
    jj_scanpos = xsp;
    if (jj_3R_246()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_238()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_82() {
    if (jj_scan_token(SHR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_79() {
    if (jj_scan_token(GE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_235() {
    if (jj_scan_token(DISPLAYB)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_81() {
    if (jj_scan_token(SHL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_78() {
    if (jj_scan_token(LE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_29() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_3R_85()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_86()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_83() {
    if (jj_3R_86()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_29()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_234() {
    if (jj_scan_token(DISPLAY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_74() {
    if (jj_scan_token(CNEQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_222() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_234()) {
    jj_scanpos = xsp;
    if (jj_3R_235()) {
    jj_scanpos = xsp;
    if (jj_3R_236()) {
    jj_scanpos = xsp;
    if (jj_3R_237()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_238()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_11() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_77() {
    if (jj_scan_token(GT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_180() {
    if (jj_3R_220()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_179() {
    if (jj_3R_219()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_178() {
    if (jj_3R_218()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_10() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_73() {
    if (jj_scan_token(CEQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_270() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_177() {
    if (jj_3R_217()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_76() {
    if (jj_scan_token(LT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_69() {
    if (jj_scan_token(BNAND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_28() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_81()) {
    jj_scanpos = xsp;
    if (jj_3R_82()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_83()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_176() {
    if (jj_3R_216()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_175() {
    if (jj_3R_215()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_269() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_174() {
    if (jj_3R_214()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_80() {
    if (jj_3R_83()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_28()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_264() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_269()) {
    jj_scanpos = xsp;
    if (jj_3R_270()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_254() {
    if (jj_scan_token(148)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_264()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_132() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_263() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_72() {
    if (jj_scan_token(NEQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_262() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_68() {
    if (jj_scan_token(BNXOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_253() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_262()) {
    jj_scanpos = xsp;
    if (jj_3R_263()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_238() {
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_253()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_254()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_71() {
    if (jj_scan_token(EQ)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_27() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_76()) {
    jj_scanpos = xsp;
    if (jj_3R_77()) {
    jj_scanpos = xsp;
    if (jj_3R_78()) {
    jj_scanpos = xsp;
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_75() {
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_27()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_67() {
    if (jj_scan_token(BAND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_223() {
    if (jj_scan_token(COUT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(146)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(147)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(POINT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(145)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_66() {
    if (jj_scan_token(BXOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_26() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_71()) {
    jj_scanpos = xsp;
    if (jj_3R_72()) {
    jj_scanpos = xsp;
    if (jj_3R_73()) {
    jj_scanpos = xsp;
    if (jj_3R_74()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_75()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public VeriParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[146];
  final private int[] jj_la1_0 = {0x0,0x0,0x0,0x3ff8000,0x6000,0x80,0x0,0x0,0x0,0x40000,0x3fb8000,0x3ff8000,0x6000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x480000,0x900000,0x1200000,0x1f80000,0x30000000,0x30000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30000000,0x30000000,0x0,0x0,0x0,0x0,0x3f80000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x48000,0x48000,0x78000,0x38000,0x78000,0x0,0x0,0x0,0x0,0x0,0xc0000000,0x40000000,0x80000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x2003e000,0xc0000000,0x0,0x0,0x0,0x0,0x2003e000,0x0,0x2003e000,0xc0000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x6000,0x2003e000,0x2003e000,0x2003e000,0x0,0x2003e000,0xed40800,0x0,0x0,0x0,0x0,0xff,0x55,0xaa,0x0,0x0,0x0,0xed40000,0x0,0x0,0x0,0x0,0x0,0xed40800,0xd00000,0x200000,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xed40800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2003e000,0xed40800,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_2 = {0x4000000,0x0,0x0,0x0,0x5,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x83fffe80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x83fffe80,0x0,0x3fffe00,0x0,0x0,0x0,0x83fffe80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x60,0x83fffe80,0x60,0x60,0x0,0x0,0x0,0x0,0x0,0x1e00,0x1e00000,0x1e0000,0x1e000,0x0,0x0,0x83fffe80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_3 = {0x0,0x4,0x0,0x4,0x0,0x0,0x0,0x5,0x5,0x0,0x4,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x67e0005,0x0,0x67e0005,0x0,0x67e0005,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xd,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x5,0x0,0xd,0x0,0x0,0x0,0x67e0005,0x0,0xd,0x0,0x67e0005,0x0,0x67e0005,0x0,0x5,0x67e0005,0x0,0x5,0x2,0x67e0005,0xd,0x0,0x0,0x67e0005,0x67e0005,0x0,0x67e0005,0x67e0005,0x0,0x0,0x0,0x0,0x0,0x0,0xd,0x80000000,0x0,0x67e0000,0x67e0005,0x0,0x5,0x0,0x6000000,0x6000000,0x20000,0x20000,0x6000000,0x6000000,0x20000,0x6000000,0x6000000,0x20000,0x6000000,0x6000000,0x20000,0x0,0x0,0x30000000,0xc0000000,0x0,0x6000000,0x9800000,0x6000000,0x6000000,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,};
  final private int[] jj_la1_4 = {0x0,0x0,0x20000,0x0,0x0,0x0,0x100000,0x4000000,0x4000000,0x0,0x0,0x0,0x0,0x200000,0x100000,0x400000,0x100000,0x400000,0x400000,0x400000,0x100000,0x400000,0x0,0x0,0x0,0x0,0x0,0x0,0x20000,0x400000,0x2000000,0x100000,0x400000,0x2000000,0x100000,0x2400000,0x0,0x0,0x20000,0x400000,0x2000000,0x100000,0x0,0x200000,0x400000,0x100000,0x400000,0x100000,0x400000,0x100000,0x100000,0x2000000,0x4030fe4,0x100000,0x4030fe4,0x100000,0x4030fe4,0x20000,0x400000,0x0,0x0,0x0,0x0,0x0,0x6080000,0x200000,0x20000,0x2000000,0x100000,0x0,0x0,0x0,0x100000,0x4000000,0x2000000,0x80000,0x20000,0x0,0x100000,0x4030fe4,0x800000,0x6080000,0x0,0x4030fe4,0x100000,0x4030fe4,0x2000000,0x6000000,0x4030fe4,0x2000000,0x6000000,0x0,0x4030fe4,0x6080000,0x0,0x0,0x4030fe4,0x4030fe4,0x100000,0x4030fe4,0x4030fe4,0x0,0x0,0x0,0x0,0x800000,0x0,0x6080000,0x200000,0x2000000,0x10000,0x4030fe4,0x100000,0x4000000,0x10000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x480,0xb40,0xc000,0x3,0x3000,0x0,0x0,0xfe4,0xfe4,0x800000,0x400000,0x800000,0x400000,0x0,0x100000,0x100000,0x20000,0x800000,};
  final private JJCalls[] jj_2_rtns = new JJCalls[33];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public VeriParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new VeriParserTokenManager(jj_input_stream);
    token = new Token();
    token.next = jj_nt = token_source.getNextToken();
    jj_gen = 0;
    for (int i = 0; i < 146; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    token.next = jj_nt = token_source.getNextToken();
    jj_gen = 0;
    for (int i = 0; i < 146; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public VeriParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new VeriParserTokenManager(jj_input_stream);
    token = new Token();
    token.next = jj_nt = token_source.getNextToken();
    jj_gen = 0;
    for (int i = 0; i < 146; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    token.next = jj_nt = token_source.getNextToken();
    jj_gen = 0;
    for (int i = 0; i < 146; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public VeriParser(VeriParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    token.next = jj_nt = token_source.getNextToken();
    jj_gen = 0;
    for (int i = 0; i < 146; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(VeriParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    token.next = jj_nt = token_source.getNextToken();
    jj_gen = 0;
    for (int i = 0; i < 146; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken = token;
    if ((token = jj_nt).next != null) jj_nt = jj_nt.next;
    else jj_nt = jj_nt.next = token_source.getNextToken();
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      trace_token(token, "");
      return token;
    }
    jj_nt = token;
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if ((token = jj_nt).next != null) jj_nt = jj_nt.next;
    else jj_nt = jj_nt.next = token_source.getNextToken();
    jj_gen++;
      trace_token(token, " (in getNextToken)");
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[157];
    for (int i = 0; i < 157; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 146; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
          if ((jj_la1_4[i] & (1<<j)) != 0) {
            la1tokens[128+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 157; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  private int trace_indent = 0;
  private boolean trace_enabled = true;

  final public void enable_tracing() {
    trace_enabled = true;
  }

  final public void disable_tracing() {
    trace_enabled = false;
  }

  final private void trace_call(String s) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Call:   " + s);
    }
    trace_indent = trace_indent + 2;
  }

  final private void trace_return(String s) {
    trace_indent = trace_indent - 2;
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Return: " + s);
    }
  }

  final private void trace_token(Token t, String where) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Consumed token: <" + tokenImage[t.kind]);
      if (t.kind != 0 && !tokenImage[t.kind].equals("\"" + t.image + "\"")) {
        System.out.print(": \"" + t.image + "\"");
      }
      System.out.println(">" + where);
    }
  }

  final private void trace_scan(Token t1, int t2) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Visited token: <" + tokenImage[t1.kind]);
      if (t1.kind != 0 && !tokenImage[t1.kind].equals("\"" + t1.image + "\"")) {
        System.out.print(": \"" + t1.image + "\"");
      }
      System.out.println(">; Expected token: <" + tokenImage[t2] + ">");
    }
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 33; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
